#if __cplusplus
#include "knaps.hpp"
#else
#include "knaps.h"
#endif

/*LINTLIBRARY*/

#define C_implementation_file

/*
module generated from VDM Class Library
$Revision: 1.101 $
$Date: 1996/09/19 09:25:46 $
*/

static Nat0 len_mfree_str = 0;

static Nat0 cnt_alloc_str = 0;
static Nat0 cnt_free_str = 0;
static Nat0 cnt_mallc_str = 0;
static Nat0 cnt_mfree_str = 0;

void profile_str (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Str");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_str);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_str);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_str);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_str);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_str);
fprintf(stderr,"\n");
}

static VOIDptr freelist_str = (VOIDptr)0;

Str alloc_str (void)
{Str x1;
cnt_alloc_str ++;
if (! freelist_str)
{while (! (x1 = (Str)ALLOCMEM_vdmlib(sizeof(struct Handle_str)))) heap_oflw_vdmlib("Heap_str");
cnt_mallc_str ++;
return x1;
}
freelist_str = *((VOIDptr *)(x1 = (Str) freelist_str));
len_mfree_str --;
return x1;
}

void free_str (Str x1)
{len_mfree_str ++;
cnt_free_str ++;
*((VOIDptr *)x1) = freelist_str;
freelist_str = (VOIDptr)x1;
if (len_mfree_str > 100)
{while (len_mfree_str > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_str);
FREEMEM_vdmlib(freelist_str,sizeof(struct Handle_str));
freelist_str = lx1;
len_mfree_str --;
cnt_mfree_str ++;
}
}
}

#ifdef __cplusplus
#define outerrstr_vdmlib(x1) cerr << x1
#define outerrint_vdmlib(x1) cerr << x1
#define outerrme1_vdmlib(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << " "
#define outerrmes_vdmlib(x1,x2) cerr << "\n\n" << x2 << " : " << x1 << "\n"
#else
#define outerrstr_vdmlib(x1) fprintf(stderr,"%s",x1)
#define outerrint_vdmlib(x1) fprintf(stderr,"%ld",x1)
#define outerrme1_vdmlib(x1,x2) fprintf(stderr,"\n\n%s : %s ",x2,x1)
#define outerrmes_vdmlib(x1,x2) fprintf(stderr,"\n\n%s : %s\n",x2,x1)
#endif
void err_empty_iterator_vdmlib (char * x1)
{
outerrmes_vdmlib("no more elements to process by an iterator",x1);
abort_vdmlib(VDM_ERR_EMPTYIT);
}

void abort_vdmlib (Nat0 x1)
{
exit(1);
}
void heap_oflw_vdmlib (char * x1)
{
outerrmes_vdmlib("no more heap space available",x1);
abort_vdmlib(VDM_ERR_HEAPOFL);
}

Bool supress_cvlines_vdmlib = TRUE;
Nat0 curr_linelen_vdmlib;
char *start_structure_vdmlib;
char *end_structure_vdmlib;

void adj_linelen_vdmlib (Nat0 x1)
{ curr_linelen_vdmlib = (curr_linelen_vdmlib > x1) ? (curr_linelen_vdmlib - x1) : 0;}

Str ident_prefix_vdmlib (Str x1,Nat0 x2)
{ return conc_str(mkn_str(' ',x2 - len_str(x1)), x1); }

Cvtext_vdmlib ident_lines_vdmlib (Cvtext_vdmlib x1,Str x2)
{ Str lx1;Nat1 lx2;

lx1 = mkn_str(' ',len_str(x2));
x1 = ovwrt1_cvtext_vdmlib( x1
, (Nat1)1
, conc_str(x2,sel_cvtext_vdmlib(x1,(Nat1)1)));
for(lx2 = 2;lx2 <= len_cvtext_vdmlib(x1); lx2++)
x1 = ovwrt1_cvtext_vdmlib( x1
, lx2
, conc_str( copy_str(lx1)
, sel_cvtext_vdmlib(x1,lx2)));
del_str(lx1);
return x1;
}

Cvtext_vdmlib close_struct_vdmlib (Cvtext_vdmlib x1,Str x2,Nat0 x3)
{ Nat0 lx1 = len_cvtext_vdmlib(x1);
Str lx2 = sel_cvtext_vdmlib(x1,(Nat1)lx1);
Nat0 lx3 = 1;

if (lx1 <= 2)
return ovwrt1_cvtext_vdmlib(x1,(Nat1)lx1,conc_str(lx2,x2));

while(sel_str(lx2,lx3) == ' ') lx3++;
if ( len_str(x2) == 1
&& sel_str(lx2,lx3) == hd_str(x2)
)
{ return ovwrt1_cvtext_vdmlib(x1
,(Nat1)lx1
,ovwrt1_str(lx2,x3,hd_str(x2)));
}

return appr_cvtext_vdmlib(x1,ident_prefix_vdmlib(x2,x3));
}

Cvtext_vdmlib append_lastline_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{ if (len_cvtext_vdmlib(x2) != 1)
{
outerrstr_vdmlib("error in 2nd parameter of 'append_lastline'");
abort_vdmlib(VDM_ERR_CVLINES);
}
{ Nat0 lx1 = len_cvtext_vdmlib(x1);

x1 = ovwrt1_cvtext_vdmlib( x1
, (Nat1)lx1
, conc_str( sel_cvtext_vdmlib(x1,(Nat1)lx1)
, conc_str( mkc_str(",")
, hd_cvtext_vdmlib(x2))));
del1_cvtext_vdmlib(x2);
return x1;
}
}

static Bool last_was_simple_vdmlib (Cvtext_vdmlib x1,Nat0 x2)
{ return ( len_cvtext_vdmlib(x1) == 1
|| index_str(last_cvtext_vdmlib(x1),',') == x2
);
}

Cvtext_vdmlib cvlines2_cvtext_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{ if (is_empty_cvtext_vdmlib(x1))
return ident_lines_vdmlib(x2,mkc_str(start_structure_vdmlib));
else
{ if ( len_cvtext_vdmlib(x2) == 1
&& len_str(hd_cvtext_vdmlib(x2))
+ len_str(last_cvtext_vdmlib(x1))
< curr_linelen_vdmlib
&& last_was_simple_vdmlib(x1,(Nat0)strlen(start_structure_vdmlib))
)
return append_lastline_vdmlib(x1,x2);
else
return conc_cvtext_vdmlib
(x1,ident_lines_vdmlib
(x2,ident_prefix_vdmlib( mkc_str(",")
, (Nat0)strlen(start_structure_vdmlib))));
}
}

#ifdef __cplusplus
void fprint_lines_vdmlib (ostream & x1,Cvtext_vdmlib x2)
#else
void fprint_lines_vdmlib (FILE * x1,Cvtext_vdmlib x2)
#endif
{ Nat1 lx1;

for (lx1 = 1;lx1 <= len_cvtext_vdmlib(x2); lx1++)
{ Nat1 lx3;
Str lx4;

lx4 = sel_cvtext_vdmlib(x2,lx1);
for (lx3 = 1; lx3 <= len_str(lx4); lx3++)
#ifdef __cplusplus
{x1 << (char)(sel_str(lx4,lx3));}
x1 << "\n";
#else
{fprintf(x1,"%c",sel_str(lx4,lx3));}
fprintf(x1,"\n");
#endif
}
}
void err_nv_hdl_vdmlib (char * x1)
{
outerrmes_vdmlib("accessed object contains no valid data",x1);
abort_vdmlib(VDM_ERR_NV_HDL);
}
void err_sel_vdmlib (Nat1 x1,Nat0 x2,char * x3)
{
outerrme1_vdmlib("attempt to select element",x3);
outerrint_vdmlib((long)x1);
outerrstr_vdmlib(" of tuple with length ");
outerrint_vdmlib((long)x2);
outerrstr_vdmlib("\n");
abort_vdmlib(VDM_ERR_SELECT);
}
void err_tl_vdmlib (char * x1)
{
outerrmes_vdmlib("attempt to take 'tl' of an empty tuple",x1);
abort_vdmlib(VDM_ERR_EMPTYTL);
}
Bool not_bool (Bool x1)  {return !x1;}
Bool is_gr_bool (Bool x1,Bool x2)   {return (x1>x2);}
Bool xor_bool (Bool x1,Bool x2)   {return x1 ^ x2;}
Bool and_bool (Bool x1,Bool x2)   {return x1 & x2;}
Bool is_eq_bool (Bool x1,Bool x2)   {return (x1==x2);}
Bool is_ge_bool (Bool x1,Bool x2)   {return (x1>=x2);}
Bool or_bool (Bool x1,Bool x2)   {return x1 | x2;}
#if __cplusplus
NILETC empty, nil, new_val;
#endif

static Nat0 len_mfree_chromosome = 0;

static Nat0 cnt_alloc_chromosome = 0;
static Nat0 cnt_free_chromosome = 0;
static Nat0 cnt_mallc_chromosome = 0;
static Nat0 cnt_mfree_chromosome = 0;

void profile_chromosome (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Chromosome");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_chromosome);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_chromosome);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_chromosome);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_chromosome);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_chromosome);
fprintf(stderr,"\n");
}

static VOIDptr freelist_chromosome = (VOIDptr)0;

Chromosome alloc_chromosome (void)
{Chromosome x1;
cnt_alloc_chromosome ++;
if (! freelist_chromosome)
{while (! (x1 = (Chromosome)ALLOCMEM_vdmlib(sizeof(struct Handle_chromosome)))) heap_oflw_vdmlib("Heap_chromosome");
cnt_mallc_chromosome ++;
return x1;
}
freelist_chromosome = *((VOIDptr *)(x1 = (Chromosome) freelist_chromosome));
len_mfree_chromosome --;
return x1;
}

void free_chromosome (Chromosome x1)
{len_mfree_chromosome ++;
cnt_free_chromosome ++;
*((VOIDptr *)x1) = freelist_chromosome;
freelist_chromosome = (VOIDptr)x1;
if (len_mfree_chromosome > 100)
{while (len_mfree_chromosome > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_chromosome);
FREEMEM_vdmlib(freelist_chromosome,sizeof(struct Handle_chromosome));
freelist_chromosome = lx1;
len_mfree_chromosome --;
cnt_mfree_chromosome ++;
}
}
}

static Nat0 len_mfree_individuals = 0;

static Nat0 cnt_alloc_individuals = 0;
static Nat0 cnt_free_individuals = 0;
static Nat0 cnt_mallc_individuals = 0;
static Nat0 cnt_mfree_individuals = 0;

void profile_individuals (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Individuals");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_individuals);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_individuals);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_individuals);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_individuals);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_individuals);
fprintf(stderr,"\n");
}

static VOIDptr freelist_individuals = (VOIDptr)0;

Individuals alloc_individuals (void)
{Individuals x1;
cnt_alloc_individuals ++;
if (! freelist_individuals)
{while (! (x1 = (Individuals)ALLOCMEM_vdmlib(sizeof(struct Handle_individuals)))) heap_oflw_vdmlib("Heap_individuals");
cnt_mallc_individuals ++;
return x1;
}
freelist_individuals = *((VOIDptr *)(x1 = (Individuals) freelist_individuals));
len_mfree_individuals --;
return x1;
}

void free_individuals (Individuals x1)
{len_mfree_individuals ++;
cnt_free_individuals ++;
*((VOIDptr *)x1) = freelist_individuals;
freelist_individuals = (VOIDptr)x1;
if (len_mfree_individuals > 100)
{while (len_mfree_individuals > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_individuals);
FREEMEM_vdmlib(freelist_individuals,sizeof(struct Handle_individuals));
freelist_individuals = lx1;
len_mfree_individuals --;
cnt_mfree_individuals ++;
}
}
}

static Nat0 len_mfree_blocks = 0;

static Nat0 cnt_alloc_blocks = 0;
static Nat0 cnt_free_blocks = 0;
static Nat0 cnt_mallc_blocks = 0;
static Nat0 cnt_mfree_blocks = 0;

void profile_blocks (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Blocks");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_blocks);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_blocks);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_blocks);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_blocks);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_blocks);
fprintf(stderr,"\n");
}

static VOIDptr freelist_blocks = (VOIDptr)0;

Blocks alloc_blocks (void)
{Blocks x1;
cnt_alloc_blocks ++;
if (! freelist_blocks)
{while (! (x1 = (Blocks)ALLOCMEM_vdmlib(sizeof(struct Handle_blocks)))) heap_oflw_vdmlib("Heap_blocks");
cnt_mallc_blocks ++;
return x1;
}
freelist_blocks = *((VOIDptr *)(x1 = (Blocks) freelist_blocks));
len_mfree_blocks --;
return x1;
}

void free_blocks (Blocks x1)
{len_mfree_blocks ++;
cnt_free_blocks ++;
*((VOIDptr *)x1) = freelist_blocks;
freelist_blocks = (VOIDptr)x1;
if (len_mfree_blocks > 100)
{while (len_mfree_blocks > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_blocks);
FREEMEM_vdmlib(freelist_blocks,sizeof(struct Handle_blocks));
freelist_blocks = lx1;
len_mfree_blocks --;
cnt_mfree_blocks ++;
}
}
}

static Nat0 len_mfree_confill = 0;

static Nat0 cnt_alloc_confill = 0;
static Nat0 cnt_free_confill = 0;
static Nat0 cnt_mallc_confill = 0;
static Nat0 cnt_mfree_confill = 0;

void profile_confill (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","ConFill");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_confill);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_confill);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_confill);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_confill);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_confill);
fprintf(stderr,"\n");
}

static VOIDptr freelist_confill = (VOIDptr)0;

ConFill alloc_confill (void)
{ConFill x1;
cnt_alloc_confill ++;
if (! freelist_confill)
{while (! (x1 = (ConFill)ALLOCMEM_vdmlib(sizeof(struct Handle_confill)))) heap_oflw_vdmlib("Heap_confill");
cnt_mallc_confill ++;
return x1;
}
freelist_confill = *((VOIDptr *)(x1 = (ConFill) freelist_confill));
len_mfree_confill --;
return x1;
}

void free_confill (ConFill x1)
{len_mfree_confill ++;
cnt_free_confill ++;
*((VOIDptr *)x1) = freelist_confill;
freelist_confill = (VOIDptr)x1;
if (len_mfree_confill > 100)
{while (len_mfree_confill > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_confill);
FREEMEM_vdmlib(freelist_confill,sizeof(struct Handle_confill));
freelist_confill = lx1;
len_mfree_confill --;
cnt_mfree_confill ++;
}
}
}

Real copy_real (Real x1)  {return x1;}
char * printformat_real = "%lg";

void set_print_format_real (char * x1)
{ printformat_real = (x1) ? x1 : "%lg"; }
Real minus_real (Real x1,Real x2)   { return (x1)-(x2); }
Real div_real (Real x1,Real x2)   { return (x1)/(x2); }
Bool is_gr_real (Real x1,Real x2)   {return (x1>x2);}
Bool is_le_real (Real x1,Real x2)   { return is_ge_real((x2),(x1)); }
Real succ_real (Real x1)  { return (x1) + 1; }
Cvtext_vdmlib cvlines_real (Real x1)
{ char lx1[50];

sprintf(lx1,printformat_real,(double)x1);
return mk1_cvtext_vdmlib(mkc_str(lx1));
}

#ifdef __cplusplus
void fpr_real (ostream & x1,Real x2)
#else
void fpr_real (FILE * x1,Real x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_real(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}
Real plus_real (Real x1,Real x2)   {return x1 + x2;}
Real times_real (Real x1,Real x2)   { return (x1)*(x2); }
Bool is_ge_real (Real x1,Real x2)   {return (x1>=x2);}
Bool is_lt_real (Real x1,Real x2)   { return is_gr_real((x2),(x1)); }
Bool is_eq_real (Real x1,Real x2)   {return (x1==x2);}
Real pred_real (Real x1)  { return (x1) - 1; }
void del_real (Real x1)  {}
char * printformat_nat1 = "%lu";

void set_print_format_nat1 (char * x1)
{ printformat_nat1 = (x1) ? x1 : "%lu"; }
Nat1 pred_nat1 (Nat1 x1)  { return (x1) - 1; }
Bool is_eq_nat1 (Nat1 x1,Nat1 x2)   {return (x1==x2);}
Bool is_lt_nat1 (Nat1 x1,Nat1 x2)   { return is_gr_nat1((x2),(x1)); }
Bool is_ge_nat1 (Nat1 x1,Nat1 x2)   {return (x1>=x2);}
Nat1 times_nat1 (Nat1 x1,Nat1 x2)   { return (x1)*(x2); }
Nat1 plus_nat1 (Nat1 x1,Nat1 x2)   {return x1 + x2;}
void del_nat1 (Nat1 x1)  {}
Nat1 copy_nat1 (Nat1 x1)  {return x1;}
Nat1 succ_nat1 (Nat1 x1)  { return (x1) + 1; }
Nat1 mod_nat1 (Nat1 x1,Nat1 x2)   { return (x1)%(x2); }
Bool is_le_nat1 (Nat1 x1,Nat1 x2)   { return is_ge_nat1((x2),(x1)); }
Bool is_gr_nat1 (Nat1 x1,Nat1 x2)   {return (x1>x2);}
Nat1 div_nat1 (Nat1 x1,Nat1 x2)   { return (x1)/(x2); }
Nat1 minus_nat1 (Nat1 x1,Nat1 x2)   { return (x1)-(x2); }
Cvtext_vdmlib cvlines_nat1 (Nat1 x1)
{ char lx1[50];

sprintf(lx1,printformat_nat1,(unsigned long)x1);
return mk1_cvtext_vdmlib(mkc_str(lx1));
}
char * printformat_nat0 = "%lu";

void set_print_format_nat0 (char * x1)
{ printformat_nat0 = (x1) ? x1 : "%lu"; }
Nat0 pred_nat0 (Nat0 x1)  { return (x1) - 1; }
Bool is_eq_nat0 (Nat0 x1,Nat0 x2)   {return (x1==x2);}
Bool is_lt_nat0 (Nat0 x1,Nat0 x2)   { return is_gr_nat0((x2),(x1)); }
Bool is_ge_nat0 (Nat0 x1,Nat0 x2)   {return (x1>=x2);}
Nat0 times_nat0 (Nat0 x1,Nat0 x2)   { return (x1)*(x2); }
Nat0 plus_nat0 (Nat0 x1,Nat0 x2)   {return x1 + x2;}
void del_nat0 (Nat0 x1)  {}
Nat0 copy_nat0 (Nat0 x1)  {return x1;}
Nat0 succ_nat0 (Nat0 x1)  { return (x1) + 1; }
Nat0 mod_nat0 (Nat0 x1,Nat0 x2)   { return (x1)%(x2); }
Bool is_le_nat0 (Nat0 x1,Nat0 x2)   { return is_ge_nat0((x2),(x1)); }
Bool is_gr_nat0 (Nat0 x1,Nat0 x2)   {return (x1>x2);}
Nat0 div_nat0 (Nat0 x1,Nat0 x2)   { return (x1)/(x2); }
Nat0 minus_nat0 (Nat0 x1,Nat0 x2)   { return (x1)-(x2); }
Cvtext_vdmlib cvlines_nat0 (Nat0 x1)
{ char lx1[50];

sprintf(lx1,printformat_nat0,(unsigned long)x1);
return mk1_cvtext_vdmlib(mkc_str(lx1));
}
Intg pred_intg (Intg x1)  { return (x1) - 1; }
Bool is_eq_intg (Intg x1,Intg x2)   {return (x1==x2);}
Bool is_lt_intg (Intg x1,Intg x2)   { return is_gr_intg((x2),(x1)); }
Bool is_ge_intg (Intg x1,Intg x2)   {return (x1>=x2);}
Intg times_intg (Intg x1,Intg x2)   { return (x1)*(x2); }
Intg plus_intg (Intg x1,Intg x2)   {return x1 + x2;}
Intg succ_intg (Intg x1)  { return (x1) + 1; }
Intg mod_intg (Intg x1,Intg x2)   { return (x1)%(x2); }
Bool is_le_intg (Intg x1,Intg x2)   { return is_ge_intg((x2),(x1)); }
Bool is_gr_intg (Intg x1,Intg x2)   {return (x1>x2);}
Intg div_intg (Intg x1,Intg x2)   { return (x1)/(x2); }
Intg minus_intg (Intg x1,Intg x2)   { return (x1)-(x2); }
Char copy_char (Char x1)  {return x1;}
Char pred_char (Char x1)  { return (x1) - 1; }
Bool is_eq_char (Char x1,Char x2)   {return (x1==x2);}
Bool is_lt_char (Char x1,Char x2)   { return is_gr_char((x2),(x1)); }
Bool is_ge_char (Char x1,Char x2)   {return (x1>=x2);}
Char times_char (Char x1,Char x2)   { return (x1)*(x2); }
Char plus_char (Char x1,Char x2)   {return x1 + x2;}
Char succ_char (Char x1)  { return (x1) + 1; }
Char mod_char (Char x1,Char x2)   { return (x1)%(x2); }
Bool is_le_char (Char x1,Char x2)   { return is_ge_char((x2),(x1)); }
Bool is_gr_char (Char x1,Char x2)   {return (x1>x2);}
Char div_char (Char x1,Char x2)   { return (x1)/(x2); }
Char minus_char (Char x1,Char x2)   { return (x1)-(x2); }
void del_char (Char x1)  {}

Rep_str alloc_rep_str (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_str) + (x1 + 0) * sizeof(Char);
Nat0 len2 = 4;
Rep_str lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_str) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_str");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_str))/sizeof(Char));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_str (Rep_str x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_str) + x1->f_max*sizeof(Char));
}

void forall_rep_str (Rep_str x1,T2_forall_rep_str x2)
{Nat0 lx1 = ref_rep_str(x1)->f_len;
Char * px1 = (Char * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}
void del1_rep_str (Rep_str x1)  {free_rep_str(x1);}

Rep_str mknc_rep_str (Char x1,Nat0 x2)
{ Rep_str y1 = alloc_rep_str(x2);
Char* y2 = ((Char *)(y1 + 1));

while(x2--) { *(y2++) = copy_char(x1); }
return y1;
}

Rep_str ovwrt1d_rep_str (Rep_str x1,Nat1 x2,Char x3)
{
if (x2 > ref_rep_str(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_str");
;
*( ((Char *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Rep_str conc_rep_str (Rep_str x1,Rep_str x2)
{Nat0 ll1 = ref_rep_str(x1)->f_len;
Nat0 ll = ll1 + ref_rep_str(x2)->f_len;
if (ll > x1->f_max)
{Rep_str lx3 = alloc_rep_str(ll);
register Nat0 i = ll1;
register Char * px3 = (Char *)(lx3 + 1);
register Char * px1 = (Char *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_str(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Char * px1 = ((Char *)( x1 + 1)) + ll1;
register Char * px2 = (Char *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_str(x2);
}
return x1;
}

void cpc_rep_str (Rep_str x1,Char * x2)
{register Nat0 li = ref_rep_str(x1)->f_len;
register Char * px1 = (Char *)(x1 + 1);
register Char * px2 = (Char *)x2;
while (li--) *(px2++) = *(px1++);
*(px2) = 0;
}
Char sel_rep_str (Rep_str x1,Nat1 x2)
{

if (x2 > ref_rep_str(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_str");
return *( ((Char *)(x1 + 1)) + x2 -1);
}

Rep_str copy_rep_str (Rep_str x1)
{Nat0 l1 = ref_rep_str(x1)->f_len;
Rep_str x2 = alloc_rep_str(l1);
register Char * px1 = (Char *)(x1+1);
register Char * px2 = (Char *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = *(px1++);
return x2;
}

Rep_str mkc_rep_str (Char * x1)
{register Nat0 li = 0;
register Char * lx1 = (Char *)x1;
while (*(lx1++)) li++;
{Rep_str x2 = alloc_rep_str(li);
register Char * lx2 = (Char *)(x2 + 1);
lx1 = (Char *)x1;
while (li--) *(lx2++) = *(lx1++);
return x2;
}
}
void del_rep_str (Rep_str x1)  {del1_rep_str(x1);}
Char hd_rep_str (Rep_str x1)  {return sel_rep_str(x1,(Nat1)1);}

static Nat0 _rr1_index_rep_str;
static Rep_str _tt1_index_rep_str; static Char _tt2_index_rep_str;

static void _ff1_index_rep_str(Char y1,Nat1 y2)

{if ((_rr1_index_rep_str == 0) && is_eq_char(y1,_tt2_index_rep_str)) _rr1_index_rep_str = y2;}

Nat0 index_rep_str(Rep_str x1,Char x2)

{Nat0 lr1; lr1 = _rr1_index_rep_str;
{Rep_str lt1; Char lt2; lt1 = _tt1_index_rep_str; lt2 = _tt2_index_rep_str;
{
{_tt1_index_rep_str = x1; _tt2_index_rep_str = x2;

{_rr1_index_rep_str = 0;
forindex_rep_str(x1,_ff1_index_rep_str);

_tt1_index_rep_str = lt1; _tt2_index_rep_str = lt2;
{Nat0 lr2; lr2 = _rr1_index_rep_str; _rr1_index_rep_str = lr1; return lr2;}
}}}}}

Nat0 len_rep_str (Rep_str x1)  {return (ref_rep_str(x1)->f_len);}

static Rep_str _tt1_forindex_rep_str; static T2_forindex_rep_str _tt2_forindex_rep_str; static Nat1 _ll1_forindex_rep_str;

static void _ff1_forindex_rep_str(Char y1)

{(*_tt2_forindex_rep_str)(y1,_ll1_forindex_rep_str++);}

void forindex_rep_str(Rep_str x1,T2_forindex_rep_str x2)

{
{Rep_str lt1; T2_forindex_rep_str lt2; lt1 = _tt1_forindex_rep_str; lt2 = _tt2_forindex_rep_str;
{Nat1 ll1; ll1 = _ll1_forindex_rep_str;
{_tt1_forindex_rep_str = x1; _tt2_forindex_rep_str = x2;
_ll1_forindex_rep_str = 1;
{
forall_rep_str(x1,_ff1_forindex_rep_str);

_tt1_forindex_rep_str = lt1; _tt2_forindex_rep_str = lt2; _ll1_forindex_rep_str = ll1;

}}}}}

Rep_chromosome alloc_rep_chromosome (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_chromosome) + (x1 + 0) * sizeof(Gen);
Nat0 len2 = 4;
Rep_chromosome lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_chromosome) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_chromosome");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_chromosome))/sizeof(Gen));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_chromosome (Rep_chromosome x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_chromosome) + x1->f_max*sizeof(Gen));
}

Rep_confill alloc_rep_confill (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_confill) + (x1 + 0) * sizeof(Nat0);
Nat0 len2 = 4;
Rep_confill lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_confill) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_confill");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_confill))/sizeof(Nat0));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_confill (Rep_confill x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_confill) + x1->f_max*sizeof(Nat0));
}

void cond_clone_str (Str * x1)
{
if ((*x1)->f_rc > 1)
{
Str clone = alloc_str();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_str((*x1)->f_rep);
*x1 = clone;
}
}

Nat0 len_str (Str x1)
{
check_handle_str(x1);
return len_rep_str (x1->f_rep  ) ;
}

Nat0 index_str (Str x1,Char x2)
{
check_handle_str(x1);
return index_rep_str (x1->f_rep , x2 ) ;
}

Char hd_str (Str x1)
{
check_handle_str(x1);
return copy_char(hd_rep_str (x1->f_rep));
}

Str conc_auto_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x2);
{
Rep_str lrep2 = copy_rep_str(x2->f_rep);
cond_clone_str(&x1);
x1->f_rep = conc_rep_str(x1->f_rep,lrep2);
}
return x1;
}

Str conc_str (Str x1,Str x2)
{
check_handle_str(x1);
check_handle_str(x1);
cond_clone_str(&x1);
x1->f_rep = conc_rep_str(x1->f_rep,x2->f_rep);
free_str(x2);
return x1;
}

Char sel_str (Str x1,Nat0 x2)
{
check_handle_str(x1);
return copy_char(sel_rep_str (x1->f_rep,x2));
}

void cpc_str (Str x1,char * x2)
{
check_handle_str(x1);
cpc_rep_str(x1->f_rep, x2);
}

Str mkc_str (char * x1)
{
Str l = alloc_str();
l->f_rc = 1;
l->f_rep = mkc_rep_str(x1);
return l;
}
void del_str (Str x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_str(x1->f_rep);
free_str(x1);
}
}
Str copy_str (Str x1)
{
check_handle_str(x1);
x1->f_rc++;
return x1;
}

Str ovwrt1_str (Str x1,Nat1 x2,Char x3)
{
check_handle_str(x1);
cond_clone_str(&x1);
x3 = copy_char(x3);
x1->f_rep = ovwrt1d_rep_str (x1->f_rep,x2,x3) ;
return x1;
}
Str mkn_str (Char x1,Nat0 x2)
{
Str l = alloc_str();
l->f_rc = 1;
l->f_rep = mknc_rep_str(x1,x2);
return l;
}

Cvtext_vdmlib alloc_cvtext_vdmlib (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_cvtext_vdmlib) + (x1 + 0) * sizeof(Str);
Nat0 len2 = 4;
Cvtext_vdmlib lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Cvtext_vdmlib) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Cvtext_vdmlib");
lx1->f_max = ((len2 - sizeof(struct Struct_cvtext_vdmlib))/sizeof(Str));
lx1->f_len = x1;
;
;
return lx1;
}

void free_cvtext_vdmlib (Cvtext_vdmlib x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_cvtext_vdmlib) + x1->f_max*sizeof(Str));
}

void forall_cvtext_vdmlib (Cvtext_vdmlib x1,T2_forall_cvtext_vdmlib x2)
{Nat0 lx1 = ref_cvtext_vdmlib(x1)->f_len;
Str * px1 = (Str * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Nat0 len_cvtext_vdmlib (Cvtext_vdmlib x1)  {return (ref_cvtext_vdmlib(x1)->f_len);}
Bool is_empty_cvtext_vdmlib (Cvtext_vdmlib x1)
{return (ref_cvtext_vdmlib(x1)->f_len == 0);}

static Cvtext_vdmlib _tt1_del_cvtext_vdmlib;

static void _ff1_del_cvtext_vdmlib(Str y1)

{del_str(y1);}

void del_cvtext_vdmlib(Cvtext_vdmlib x1)

{
{Cvtext_vdmlib lt1; lt1 = _tt1_del_cvtext_vdmlib;
{
{_tt1_del_cvtext_vdmlib = x1;

{
forall_cvtext_vdmlib(x1,_ff1_del_cvtext_vdmlib);
del1_cvtext_vdmlib(x1);
_tt1_del_cvtext_vdmlib = lt1;

}}}}}

Str hd_cvtext_vdmlib (Cvtext_vdmlib x1)  {return sel_cvtext_vdmlib(x1,(Nat1)1);}

Cvtext_vdmlib ovwrt1_cvtext_vdmlib (Cvtext_vdmlib x1,Nat1 x2,Str x3)
{
if (x2 > ref_cvtext_vdmlib(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Cvtext_vdmlib");
;
*( ((Str *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Cvtext_vdmlib mk1_cvtext_vdmlib(Str x1)
{Cvtext_vdmlib lx1 = alloc_cvtext_vdmlib((Nat0)1);
*((Str *)(lx1+1)) = x1;
return lx1;
}

Cvtext_vdmlib appr_cvtext_vdmlib (Cvtext_vdmlib x1,Str x2)
{ Nat0 lx1 = ref_cvtext_vdmlib(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Str *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_cvtext_vdmlib(x1,mk1_cvtext_vdmlib(x2)); }
}

Cvtext_vdmlib conc_cvtext_vdmlib (Cvtext_vdmlib x1,Cvtext_vdmlib x2)
{Nat0 ll1 = ref_cvtext_vdmlib(x1)->f_len;
Nat0 ll = ll1 + ref_cvtext_vdmlib(x2)->f_len;
if (ll > x1->f_max)
{Cvtext_vdmlib lx3 = alloc_cvtext_vdmlib(ll);
register Nat0 i = ll1;
register Str * px3 = (Str *)(lx3 + 1);
register Str * px1 = (Str *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_cvtext_vdmlib(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Str * px1 = ((Str *)( x1 + 1)) + ll1;
register Str * px2 = (Str *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_cvtext_vdmlib(x2);
}
return x1;
}

Cvtext_vdmlib mk_empty_cvtext_vdmlib (void)
{return alloc_cvtext_vdmlib((Nat0)0);}
Str last_cvtext_vdmlib (Cvtext_vdmlib x1)
{return sel_cvtext_vdmlib(x1,(Nat1)(len_cvtext_vdmlib(x1)));}
Str sel_cvtext_vdmlib (Cvtext_vdmlib x1,Nat1 x2)
{

if (x2 > ref_cvtext_vdmlib(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Cvtext_vdmlib");
return *( ((Str *)(x1 + 1)) + x2 -1);
}
void del1_cvtext_vdmlib (Cvtext_vdmlib x1)  {free_cvtext_vdmlib(x1);}

Rep_chromosome sub_tupd_rep_chromosome (Rep_chromosome x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_chromosome(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_gen( ((Gen *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_gen( ((Gen *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Gen * px1 = (Gen *)(x1+1);
/* start of array */
register Gen * px2 = px1 + (x2 - 1);
/* start of substring */
register Gen * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

static Rep_chromosome _tt1_forindex_rep_chromosome; static T2_forindex_rep_chromosome _tt2_forindex_rep_chromosome; static Nat1 _ll1_forindex_rep_chromosome;

static void _ff1_forindex_rep_chromosome(Gen y1)

{(*_tt2_forindex_rep_chromosome)(y1,_ll1_forindex_rep_chromosome++);}

void forindex_rep_chromosome(Rep_chromosome x1,T2_forindex_rep_chromosome x2)

{
{Rep_chromosome lt1; T2_forindex_rep_chromosome lt2; lt1 = _tt1_forindex_rep_chromosome; lt2 = _tt2_forindex_rep_chromosome;
{Nat1 ll1; ll1 = _ll1_forindex_rep_chromosome;
{_tt1_forindex_rep_chromosome = x1; _tt2_forindex_rep_chromosome = x2;
_ll1_forindex_rep_chromosome = 1;
{
forall_rep_chromosome(x1,_ff1_forindex_rep_chromosome);

_tt1_forindex_rep_chromosome = lt1; _tt2_forindex_rep_chromosome = lt2; _ll1_forindex_rep_chromosome = ll1;

}}}}}

Rep_chromosome mk1_rep_chromosome(Gen x1)
{Rep_chromosome lx1 = alloc_rep_chromosome((Nat0)1);
*((Gen *)(lx1+1)) = x1;
return lx1;
}

Rep_chromosome mknc_rep_chromosome (Gen x1,Nat0 x2)
{ Rep_chromosome y1 = alloc_rep_chromosome(x2);
Gen* y2 = ((Gen *)(y1 + 1));

while(x2--) { *(y2++) = copy_gen(x1); }
return y1;
}

Rep_chromosome ovwrt1d_rep_chromosome (Rep_chromosome x1,Nat1 x2,Gen x3)
{
if (x2 > ref_rep_chromosome(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_chromosome");
del_gen(*( ((Gen *)(x1 + 1)) + x2 -1));
*( ((Gen *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Rep_chromosome copy_rep_chromosome (Rep_chromosome x1)
{Nat0 l1 = ref_rep_chromosome(x1)->f_len;
Rep_chromosome x2 = alloc_rep_chromosome(l1);
register Gen * px1 = (Gen *)(x1+1);
register Gen * px2 = (Gen *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_gen(*(px1++));
return x2;
}

static Rep_chromosome _rr1_rmv1d_rep_chromosome;
static Rep_chromosome _tt1_rmv1d_rep_chromosome; static Nat1 _tt2_rmv1d_rep_chromosome;

static void _ff1_rmv1d_rep_chromosome(Gen y1,Nat1 y2)

{if (y2 == _tt2_rmv1d_rep_chromosome) del_gen(y1); else _rr1_rmv1d_rep_chromosome = appr_rep_chromosome(_rr1_rmv1d_rep_chromosome,y1);}

Rep_chromosome rmv1d_rep_chromosome(Rep_chromosome x1,Nat1 x2)

{Rep_chromosome lr1; lr1 = _rr1_rmv1d_rep_chromosome;
{Rep_chromosome lt1; Nat1 lt2; lt1 = _tt1_rmv1d_rep_chromosome; lt2 = _tt2_rmv1d_rep_chromosome;
{
{_tt1_rmv1d_rep_chromosome = x1; _tt2_rmv1d_rep_chromosome = x2;

{_rr1_rmv1d_rep_chromosome = mk_empty_rep_chromosome();
forindex_rep_chromosome(x1,_ff1_rmv1d_rep_chromosome);
del1_rep_chromosome(x1);
_tt1_rmv1d_rep_chromosome = lt1; _tt2_rmv1d_rep_chromosome = lt2;
{Rep_chromosome lr2; lr2 = _rr1_rmv1d_rep_chromosome; _rr1_rmv1d_rep_chromosome = lr1; return lr2;}
}}}}}

Cvtext_vdmlib cvlines_rep_chromosome (Rep_chromosome x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_chromosome(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_chromosome(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_chromosome conc_rep_chromosome (Rep_chromosome x1,Rep_chromosome x2)
{Nat0 ll1 = ref_rep_chromosome(x1)->f_len;
Nat0 ll = ll1 + ref_rep_chromosome(x2)->f_len;
if (ll > x1->f_max)
{Rep_chromosome lx3 = alloc_rep_chromosome(ll);
register Nat0 i = ll1;
register Gen * px3 = (Gen *)(lx3 + 1);
register Gen * px1 = (Gen *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_chromosome(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Gen * px1 = ((Gen *)( x1 + 1)) + ll1;
register Gen * px2 = (Gen *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_chromosome(x2);
}
return x1;
}

Rep_chromosome tld_rep_chromosome (Rep_chromosome x1)
{
if (ref_rep_chromosome(x1)->f_len == 0) { err_tl_vdmlib("Rep_chromosome"); }
return sub_tupd_rep_chromosome(x1,(Nat1)2,x1->f_len);
}

static Rep_chromosome _tt1_del_rep_chromosome;

static void _ff1_del_rep_chromosome(Gen y1)

{del_gen(y1);}

void del_rep_chromosome(Rep_chromosome x1)

{
{Rep_chromosome lt1; lt1 = _tt1_del_rep_chromosome;
{
{_tt1_del_rep_chromosome = x1;

{
forall_rep_chromosome(x1,_ff1_del_rep_chromosome);
del1_rep_chromosome(x1);
_tt1_del_rep_chromosome = lt1;

}}}}}

void del1_rep_chromosome (Rep_chromosome x1)  {free_rep_chromosome(x1);}
Rep_chromosome appr_rep_chromosome (Rep_chromosome x1,Gen x2)
{ Nat0 lx1 = ref_rep_chromosome(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Gen *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_chromosome(x1,mk1_rep_chromosome(x2)); }
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_gen
extern Cvtext_vdmlib cvlines_gen ( Gen y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_chromosome;
static void _rf1_cvlines1_rep_chromosome(Gen y1 )

{_rr1_cvlines1_rep_chromosome = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_chromosome,cvlines_gen(y1 )  );}

Cvtext_vdmlib cvlines1_rep_chromosome(Rep_chromosome x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_chromosome;
_rr1_cvlines1_rep_chromosome = mk_empty_cvtext_vdmlib();
forall_rep_chromosome(x1,_rf1_cvlines1_rep_chromosome);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_chromosome; _rr1_cvlines1_rep_chromosome = lr1; return lr2;}
}

Gen sel_rep_chromosome (Rep_chromosome x1,Nat1 x2)
{

if (x2 > ref_rep_chromosome(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_chromosome");
return *( ((Gen *)(x1 + 1)) + x2 -1);
}
void forall_rep_chromosome (Rep_chromosome x1,T2_forall_rep_chromosome x2)
{Nat0 lx1 = ref_rep_chromosome(x1)->f_len;
Gen * px1 = (Gen * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1   );
#endif
#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1   );
#endif

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

Cvtext_vdmlib cvlines1_rep_container(Rep_container x1   )

{Cvtext_vdmlib lr1 = mk_empty_cvtext_vdmlib();

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat0(s_rep_cwidth_container_rep_container(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat0(s_rep_cheight_container_rep_container(x1)  )  );

return lr1;
}

void del_rep_container (Rep_container x1)
{

del_nat0(s_rep_cwidth_container_rep_container(x1));

del_nat0(s_rep_cheight_container_rep_container(x1));

del1_rep_container(x1);
}

Rep_container chg_rep_cwidth_container_rep_container(Rep_container x1,Nat0 x2_rep_cwidth_container_rep_container)   {x1.f_rep_cwidth_container_rep_container = x2_rep_cwidth_container_rep_container;return x1;}

Rep_container chg_rep_cheight_container_rep_container(Rep_container x1,Nat0 x2_rep_cheight_container_rep_container)   {x1.f_rep_cheight_container_rep_container = x2_rep_cheight_container_rep_container;return x1;}

Cvtext_vdmlib cvlines_rep_container (Rep_container x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "mk_container(";
end_structure_vdmlib = ")";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (0)
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_container(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_container copy_rep_container (Rep_container x1)
{

x1.f_rep_cwidth_container_rep_container = copy_nat0(x1.f_rep_cwidth_container_rep_container);

x1.f_rep_cheight_container_rep_container = copy_nat0(x1.f_rep_cheight_container_rep_container);

return x1;
}
Rep_container mk_rep_container(

Nat0 x1_rep_cwidth_container_rep_container
,
Nat0 x1_rep_cheight_container_rep_container

)

{Rep_container lx1;

lx1.f_rep_cwidth_container_rep_container = x1_rep_cwidth_container_rep_container;

lx1.f_rep_cheight_container_rep_container = x1_rep_cheight_container_rep_container;

return lx1;
}

#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1   );
#endif
#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1   );
#endif
#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1   );
#endif
#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1   );
#endif

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

Cvtext_vdmlib cvlines1_rep_block(Rep_block x1   )

{Cvtext_vdmlib lr1 = mk_empty_cvtext_vdmlib();

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat0(s_rep_bwidth_block_rep_block(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat0(s_rep_bheight_block_rep_block(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat0(s_rep_x_block_rep_block(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat0(s_rep_y_block_rep_block(x1)  )  );

return lr1;
}

void del_rep_block (Rep_block x1)
{

del_nat0(s_rep_bwidth_block_rep_block(x1));

del_nat0(s_rep_bheight_block_rep_block(x1));

del_nat0(s_rep_x_block_rep_block(x1));

del_nat0(s_rep_y_block_rep_block(x1));

del1_rep_block(x1);
}

Rep_block chg_rep_bwidth_block_rep_block(Rep_block x1,Nat0 x2_rep_bwidth_block_rep_block)   {x1.f_rep_bwidth_block_rep_block = x2_rep_bwidth_block_rep_block;return x1;}

Rep_block chg_rep_bheight_block_rep_block(Rep_block x1,Nat0 x2_rep_bheight_block_rep_block)   {x1.f_rep_bheight_block_rep_block = x2_rep_bheight_block_rep_block;return x1;}

Rep_block chg_rep_x_block_rep_block(Rep_block x1,Nat0 x2_rep_x_block_rep_block)   {x1.f_rep_x_block_rep_block = x2_rep_x_block_rep_block;return x1;}

Rep_block chg_rep_y_block_rep_block(Rep_block x1,Nat0 x2_rep_y_block_rep_block)   {x1.f_rep_y_block_rep_block = x2_rep_y_block_rep_block;return x1;}

Cvtext_vdmlib cvlines_rep_block (Rep_block x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "mk_block(";
end_structure_vdmlib = ")";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (0)
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_block(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_block copy_rep_block (Rep_block x1)
{

x1.f_rep_bwidth_block_rep_block = copy_nat0(x1.f_rep_bwidth_block_rep_block);

x1.f_rep_bheight_block_rep_block = copy_nat0(x1.f_rep_bheight_block_rep_block);

x1.f_rep_x_block_rep_block = copy_nat0(x1.f_rep_x_block_rep_block);

x1.f_rep_y_block_rep_block = copy_nat0(x1.f_rep_y_block_rep_block);

return x1;
}
Rep_block mk_rep_block(

Nat0 x1_rep_bwidth_block_rep_block
,
Nat0 x1_rep_bheight_block_rep_block
,
Nat0 x1_rep_x_block_rep_block
,
Nat0 x1_rep_y_block_rep_block

)

{Rep_block lx1;

lx1.f_rep_bwidth_block_rep_block = x1_rep_bwidth_block_rep_block;

lx1.f_rep_bheight_block_rep_block = x1_rep_bheight_block_rep_block;

lx1.f_rep_x_block_rep_block = x1_rep_x_block_rep_block;

lx1.f_rep_y_block_rep_block = x1_rep_y_block_rep_block;

return lx1;
}
void forall_rep_confill (Rep_confill x1,T2_forall_rep_confill x2)
{Nat0 lx1 = ref_rep_confill(x1)->f_len;
Nat0 * px1 = (Nat0 * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Rep_confill sub_tupd_rep_confill (Rep_confill x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_confill(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_nat0( ((Nat0 *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_nat0( ((Nat0 *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Nat0 * px1 = (Nat0 *)(x1+1);
/* start of array */
register Nat0 * px2 = px1 + (x2 - 1);
/* start of substring */
register Nat0 * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_confill;
static void _rf1_cvlines1_rep_confill(Nat0 y1 )

{_rr1_cvlines1_rep_confill = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_confill,cvlines_nat0(y1 )  );}

Cvtext_vdmlib cvlines1_rep_confill(Rep_confill x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_confill;
_rr1_cvlines1_rep_confill = mk_empty_cvtext_vdmlib();
forall_rep_confill(x1,_rf1_cvlines1_rep_confill);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_confill; _rr1_cvlines1_rep_confill = lr1; return lr2;}
}

static Rep_confill _tt1_del_rep_confill;

static void _ff1_del_rep_confill(Nat0 y1)

{del_nat0(y1);}

void del_rep_confill(Rep_confill x1)

{
{Rep_confill lt1; lt1 = _tt1_del_rep_confill;
{
{_tt1_del_rep_confill = x1;

{
forall_rep_confill(x1,_ff1_del_rep_confill);
del1_rep_confill(x1);
_tt1_del_rep_confill = lt1;

}}}}}

Rep_confill appr_rep_confill (Rep_confill x1,Nat0 x2)
{ Nat0 lx1 = ref_rep_confill(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Nat0 *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_confill(x1,mk1_rep_confill(x2)); }
}

Cvtext_vdmlib cvlines_rep_confill (Rep_confill x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_confill(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_confill(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_confill ovwrt1d_rep_confill (Rep_confill x1,Nat1 x2,Nat0 x3)
{
if (x2 > ref_rep_confill(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_confill");
del_nat0(*( ((Nat0 *)(x1 + 1)) + x2 -1));
*( ((Nat0 *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Rep_confill copy_rep_confill (Rep_confill x1)
{Nat0 l1 = ref_rep_confill(x1)->f_len;
Rep_confill x2 = alloc_rep_confill(l1);
register Nat0 * px1 = (Nat0 *)(x1+1);
register Nat0 * px2 = (Nat0 *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_nat0(*(px1++));
return x2;
}

Rep_confill mknc_rep_confill (Nat0 x1,Nat0 x2)
{ Rep_confill y1 = alloc_rep_confill(x2);
Nat0* y2 = ((Nat0 *)(y1 + 1));

while(x2--) { *(y2++) = copy_nat0(x1); }
return y1;
}

Rep_confill conc_rep_confill (Rep_confill x1,Rep_confill x2)
{Nat0 ll1 = ref_rep_confill(x1)->f_len;
Nat0 ll = ll1 + ref_rep_confill(x2)->f_len;
if (ll > x1->f_max)
{Rep_confill lx3 = alloc_rep_confill(ll);
register Nat0 i = ll1;
register Nat0 * px3 = (Nat0 *)(lx3 + 1);
register Nat0 * px1 = (Nat0 *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_confill(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Nat0 * px1 = ((Nat0 *)( x1 + 1)) + ll1;
register Nat0 * px2 = (Nat0 *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_confill(x2);
}
return x1;
}

Rep_confill tld_rep_confill (Rep_confill x1)
{
if (ref_rep_confill(x1)->f_len == 0) { err_tl_vdmlib("Rep_confill"); }
return sub_tupd_rep_confill(x1,(Nat1)2,x1->f_len);
}

Rep_confill mk1_rep_confill(Nat0 x1)
{Rep_confill lx1 = alloc_rep_confill((Nat0)1);
*((Nat0 *)(lx1+1)) = x1;
return lx1;
}

Nat0 sel_rep_confill (Rep_confill x1,Nat1 x2)
{

if (x2 > ref_rep_confill(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_confill");
return *( ((Nat0 *)(x1 + 1)) + x2 -1);
}
void del1_rep_confill (Rep_confill x1)  {free_rep_confill(x1);}
void cond_clone_chromosome (Chromosome * x1)
{
if ((*x1)->f_rc > 1)
{
Chromosome clone = alloc_chromosome();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_chromosome((*x1)->f_rep);
*x1 = clone;
}
}
Chromosome copy_chromosome (Chromosome x1)
{
check_handle_chromosome(x1);
x1->f_rc++;
return x1;
}

Nat0 len_chromosome (Chromosome x1)
{
check_handle_chromosome(x1);
return len_rep_chromosome (x1->f_rep  ) ;
}

Chromosome appr_chromosome (Chromosome x1,Gen x2)
{
check_handle_chromosome(x1);
cond_clone_chromosome(&x1);
x2 = copy_gen(x2);
x1->f_rep = appr_rep_chromosome (x1->f_rep,x2) ;
return x1;
}
Chromosome appl_chromosome (Gen x1,Chromosome x2)
{
check_handle_chromosome(x2);
cond_clone_chromosome(&x2);
x1 = copy_gen(x1);
x2->f_rep = appl_rep_chromosome(x1,x2->f_rep);
return x2;
}

Bool is_empty_chromosome (Chromosome x1)
{
check_handle_chromosome(x1);
return is_empty_rep_chromosome (x1->f_rep  ) ;
}

Cvtext_vdmlib cvlines_chromosome (Chromosome x1)
{
check_handle_chromosome(x1);
return cvlines_rep_chromosome (x1->f_rep  ) ;
}

Chromosome ovwrt1_chromosome (Chromosome x1,Nat1 x2,Gen x3)
{
check_handle_chromosome(x1);
cond_clone_chromosome(&x1);
x3 = copy_gen(x3);
x1->f_rep = ovwrt1d_rep_chromosome (x1->f_rep,x2,x3) ;
return x1;
}

Chromosome rmv1_chromosome (Chromosome x1,Nat1 x2)
{
check_handle_chromosome(x1);
cond_clone_chromosome(&x1);
x1->f_rep = rmv1d_rep_chromosome (x1->f_rep,x2) ;
return x1;
}
Chromosome mkn_chromosome (Gen x1,Nat0 x2)
{
Chromosome l = alloc_chromosome();
l->f_rc = 1;
l->f_rep = mknc_rep_chromosome(x1,x2);
return l;
}

#ifdef __cplusplus
void fpr_chromosome (ostream & x1,Chromosome x2)
#else
void fpr_chromosome (FILE * x1,Chromosome x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_chromosome(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Chromosome mk_empty_chromosome (void)
{
Chromosome l = alloc_chromosome();
l->f_rc = 1;
l->f_rep = mk_empty_rep_chromosome ();
return l;
}

Gen hd_chromosome (Chromosome x1)
{
check_handle_chromosome(x1);
return copy_gen(hd_rep_chromosome (x1->f_rep));
}

Chromosome conc_chromosome (Chromosome x1,Chromosome x2)
{
check_handle_chromosome(x1);
check_handle_chromosome(x2);
{
Rep_chromosome lrep2 = copy_rep_chromosome(x2->f_rep);
cond_clone_chromosome(&x1);
x1->f_rep = conc_rep_chromosome(x1->f_rep,lrep2);
}
return x1;
}

Chromosome tl_chromosome (Chromosome x1)
{
check_handle_chromosome(x1);
cond_clone_chromosome(&x1);
x1->f_rep = tld_rep_chromosome(x1->f_rep);
return x1;
}

Gen sel_chromosome (Chromosome x1,Nat0 x2)
{
check_handle_chromosome(x1);
return copy_gen(sel_rep_chromosome (x1->f_rep,x2));
}

Chromosome mk1_chromosome (Gen x1)
{
Chromosome l = alloc_chromosome();
l->f_rc = 1;
x1 = copy_gen(x1);
l->f_rep = mk1_rep_chromosome (x1);
return l;
}
void del_chromosome (Chromosome x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_chromosome(x1->f_rep);
free_chromosome(x1);
}
}
void cond_clone_container (Container * x1)
{
if ((*x1)->f_rc > 1)
{
Container clone = alloc_container();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_container((*x1)->f_rep);
*x1 = clone;
}
}
Container copy_container (Container x1)
{
check_handle_container(x1);
x1->f_rc++;
return x1;
}
void del_container (Container x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_container(x1->f_rep);
free_container(x1);
}
}

Nat0 s_cwidth_container(Container x1) { check_handle_container(x1); return copy_nat0(s_rep_cwidth_container_rep_container(x1->f_rep)); }

Nat0 s_cheight_container(Container x1) { check_handle_container(x1); return copy_nat0(s_rep_cheight_container_rep_container(x1->f_rep)); }

Container mk_container(

Nat0 x_cwidth_container
,
Nat0 x_cheight_container

)
{
Container l = alloc_container();
l->f_rc = 1;

x_cwidth_container = copy_nat0( x_cwidth_container );

x_cheight_container = copy_nat0( x_cheight_container );

l->f_rep = mk_rep_container(

x_cwidth_container
,
x_cheight_container

);
return l;
}

#ifdef __cplusplus
void fpr_container (ostream & x1,Container x2)
#else
void fpr_container (FILE * x1,Container x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_container(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Cvtext_vdmlib cvlines_container (Container x1)
{
check_handle_container(x1);
return cvlines_rep_container (x1->f_rep  ) ;
}

Container chg_cwidth_container(Container x1,Nat0 x2) { check_handle_container(x1); cond_clone_container(&x1); x2 = copy_nat0(x2); del_nat0(s_rep_cwidth_container_rep_container(x1->f_rep)); x1->f_rep = chg_rep_cwidth_container_rep_container (x1->f_rep,x2); return x1; }

Container chg_cheight_container(Container x1,Nat0 x2) { check_handle_container(x1); cond_clone_container(&x1); x2 = copy_nat0(x2); del_nat0(s_rep_cheight_container_rep_container(x1->f_rep)); x1->f_rep = chg_rep_cheight_container_rep_container (x1->f_rep,x2); return x1; }

void cond_clone_block (Block * x1)
{
if ((*x1)->f_rc > 1)
{
Block clone = alloc_block();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_block((*x1)->f_rep);
*x1 = clone;
}
}

Block chg_bwidth_block(Block x1,Nat0 x2) { check_handle_block(x1); cond_clone_block(&x1); x2 = copy_nat0(x2); del_nat0(s_rep_bwidth_block_rep_block(x1->f_rep)); x1->f_rep = chg_rep_bwidth_block_rep_block (x1->f_rep,x2); return x1; }

Block chg_bheight_block(Block x1,Nat0 x2) { check_handle_block(x1); cond_clone_block(&x1); x2 = copy_nat0(x2); del_nat0(s_rep_bheight_block_rep_block(x1->f_rep)); x1->f_rep = chg_rep_bheight_block_rep_block (x1->f_rep,x2); return x1; }

Block chg_x_block(Block x1,Nat0 x2) { check_handle_block(x1); cond_clone_block(&x1); x2 = copy_nat0(x2); del_nat0(s_rep_x_block_rep_block(x1->f_rep)); x1->f_rep = chg_rep_x_block_rep_block (x1->f_rep,x2); return x1; }

Block chg_y_block(Block x1,Nat0 x2) { check_handle_block(x1); cond_clone_block(&x1); x2 = copy_nat0(x2); del_nat0(s_rep_y_block_rep_block(x1->f_rep)); x1->f_rep = chg_rep_y_block_rep_block (x1->f_rep,x2); return x1; }

Cvtext_vdmlib cvlines_block (Block x1)
{
check_handle_block(x1);
return cvlines_rep_block (x1->f_rep  ) ;
}

#ifdef __cplusplus
void fpr_block (ostream & x1,Block x2)
#else
void fpr_block (FILE * x1,Block x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_block(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}
Block copy_block (Block x1)
{
check_handle_block(x1);
x1->f_rc++;
return x1;
}

Block mk_block(

Nat0 x_bwidth_block
,
Nat0 x_bheight_block
,
Nat0 x_x_block
,
Nat0 x_y_block

)
{
Block l = alloc_block();
l->f_rc = 1;

x_bwidth_block = copy_nat0( x_bwidth_block );

x_bheight_block = copy_nat0( x_bheight_block );

x_x_block = copy_nat0( x_x_block );

x_y_block = copy_nat0( x_y_block );

l->f_rep = mk_rep_block(

x_bwidth_block
,
x_bheight_block
,
x_x_block
,
x_y_block

);
return l;
}

Nat0 s_bwidth_block(Block x1) { check_handle_block(x1); return copy_nat0(s_rep_bwidth_block_rep_block(x1->f_rep)); }

Nat0 s_bheight_block(Block x1) { check_handle_block(x1); return copy_nat0(s_rep_bheight_block_rep_block(x1->f_rep)); }

Nat0 s_x_block(Block x1) { check_handle_block(x1); return copy_nat0(s_rep_x_block_rep_block(x1->f_rep)); }

Nat0 s_y_block(Block x1) { check_handle_block(x1); return copy_nat0(s_rep_y_block_rep_block(x1->f_rep)); }

void del_block (Block x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_block(x1->f_rep);
free_block(x1);
}
}
void cond_clone_confill (ConFill * x1)
{
if ((*x1)->f_rc > 1)
{
ConFill clone = alloc_confill();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_confill((*x1)->f_rep);
*x1 = clone;
}
}
void del_confill (ConFill x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_confill(x1->f_rep);
free_confill(x1);
}
}

ConFill mk1_confill (Nat0 x1)
{
ConFill l = alloc_confill();
l->f_rc = 1;
x1 = copy_nat0(x1);
l->f_rep = mk1_rep_confill (x1);
return l;
}

Nat0 sel_confill (ConFill x1,Nat0 x2)
{
check_handle_confill(x1);
return copy_nat0(sel_rep_confill (x1->f_rep,x2));
}
ConFill tl_confill (ConFill x1)
{
check_handle_confill(x1);
cond_clone_confill(&x1);
x1->f_rep = tld_rep_confill(x1->f_rep);
return x1;
}

ConFill conc_confill (ConFill x1,ConFill x2)
{
check_handle_confill(x1);
check_handle_confill(x2);
{
Rep_confill lrep2 = copy_rep_confill(x2->f_rep);
cond_clone_confill(&x1);
x1->f_rep = conc_rep_confill(x1->f_rep,lrep2);
}
return x1;
}

Nat0 hd_confill (ConFill x1)
{
check_handle_confill(x1);
return copy_nat0(hd_rep_confill (x1->f_rep));
}

ConFill mk_empty_confill (void)
{
ConFill l = alloc_confill();
l->f_rc = 1;
l->f_rep = mk_empty_rep_confill ();
return l;
}

#ifdef __cplusplus
void fpr_confill (ostream & x1,ConFill x2)
#else
void fpr_confill (FILE * x1,ConFill x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_confill(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}
ConFill mkn_confill (Nat0 x1,Nat0 x2)
{
ConFill l = alloc_confill();
l->f_rc = 1;
l->f_rep = mknc_rep_confill(x1,x2);
return l;
}

ConFill ovwrt1_confill (ConFill x1,Nat1 x2,Nat0 x3)
{
check_handle_confill(x1);
cond_clone_confill(&x1);
x3 = copy_nat0(x3);
x1->f_rep = ovwrt1d_rep_confill (x1->f_rep,x2,x3) ;
return x1;
}

Cvtext_vdmlib cvlines_confill (ConFill x1)
{
check_handle_confill(x1);
return cvlines_rep_confill (x1->f_rep  ) ;
}

Bool is_empty_confill (ConFill x1)
{
check_handle_confill(x1);
return is_empty_rep_confill (x1->f_rep  ) ;
}

ConFill appl_confill (Nat0 x1,ConFill x2)
{
check_handle_confill(x2);
cond_clone_confill(&x2);
x1 = copy_nat0(x1);
x2->f_rep = appl_rep_confill(x1,x2->f_rep);
return x2;
}

ConFill appr_confill (ConFill x1,Nat0 x2)
{
check_handle_confill(x1);
cond_clone_confill(&x1);
x2 = copy_nat0(x2);
x1->f_rep = appr_rep_confill (x1->f_rep,x2) ;
return x1;
}

Nat0 len_confill (ConFill x1)
{
check_handle_confill(x1);
return len_rep_confill (x1->f_rep  ) ;
}

Iter_rep_chromosome mk_iter_rep_chromosome (Rep_chromosome x1)  {
Iter_rep_chromosome lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_chromosome (Iter_rep_chromosome * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_chromosome");
x1->f_curser++;
}

Gen sel_iter_rep_chromosome (Iter_rep_chromosome * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_chromosome");

return
*(((Gen *)(x1->f_array +1)) + x1->f_curser);
}

Iter_rep_confill mk_iter_rep_confill (Rep_confill x1)  {
Iter_rep_confill lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_confill (Iter_rep_confill * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_confill");
x1->f_curser++;
}

Nat0 sel_iter_rep_confill (Iter_rep_confill * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_confill");

return
*(((Nat0 *)(x1->f_array +1)) + x1->f_curser);
}

Rep_blocks alloc_rep_blocks (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_blocks) + (x1 + 0) * sizeof(Block);
Nat0 len2 = 4;
Rep_blocks lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_blocks) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_blocks");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_blocks))/sizeof(Block));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_blocks (Rep_blocks x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_blocks) + x1->f_max*sizeof(Block));
}

Iter_chromosome mk_iter_chromosome (Chromosome x1)  {
Iter_chromosome lx1;
check_handle_chromosome(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_chromosome(x1->f_rep);
return lx1;
}
Iter_confill mk_iter_confill (ConFill x1)  {
Iter_confill lx1;
check_handle_confill(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_confill(x1->f_rep);
return lx1;
}

#ifndef cvlines_chromosome
extern Cvtext_vdmlib cvlines_chromosome ( Chromosome x1   );
#endif
#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real x1   );
#endif

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

Cvtext_vdmlib cvlines1_rep_individual(Rep_individual x1   )

{Cvtext_vdmlib lr1 = mk_empty_cvtext_vdmlib();

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_chromosome(s_rep_chrom_individual_rep_individual(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_real(s_rep_fitness_individual_rep_individual(x1)  )  );

return lr1;
}

void del_rep_individual (Rep_individual x1)
{

del_chromosome(s_rep_chrom_individual_rep_individual(x1));

del_real(s_rep_fitness_individual_rep_individual(x1));

del1_rep_individual(x1);
}

Rep_individual chg_rep_chrom_individual_rep_individual(Rep_individual x1,Chromosome x2_rep_chrom_individual_rep_individual)   {x1.f_rep_chrom_individual_rep_individual = x2_rep_chrom_individual_rep_individual;return x1;}

Rep_individual chg_rep_fitness_individual_rep_individual(Rep_individual x1,Real x2_rep_fitness_individual_rep_individual)   {x1.f_rep_fitness_individual_rep_individual = x2_rep_fitness_individual_rep_individual;return x1;}

Cvtext_vdmlib cvlines_rep_individual (Rep_individual x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "mk_individual(";
end_structure_vdmlib = ")";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (0)
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_individual(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_individual copy_rep_individual (Rep_individual x1)
{

x1.f_rep_chrom_individual_rep_individual = copy_chromosome(x1.f_rep_chrom_individual_rep_individual);

x1.f_rep_fitness_individual_rep_individual = copy_real(x1.f_rep_fitness_individual_rep_individual);

return x1;
}
Rep_individual mk_rep_individual(

Chromosome x1_rep_chrom_individual_rep_individual
,
Real x1_rep_fitness_individual_rep_individual

)

{Rep_individual lx1;

lx1.f_rep_chrom_individual_rep_individual = x1_rep_chrom_individual_rep_individual;

lx1.f_rep_fitness_individual_rep_individual = x1_rep_fitness_individual_rep_individual;

return lx1;
}

static Nat0 len_mfree_container = 0;

static Nat0 cnt_alloc_container = 0;
static Nat0 cnt_free_container = 0;
static Nat0 cnt_mallc_container = 0;
static Nat0 cnt_mfree_container = 0;

void profile_container (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Container");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_container);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_container);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_container);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_container);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_container);
fprintf(stderr,"\n");
}

static VOIDptr freelist_container = (VOIDptr)0;

Container alloc_container (void)
{Container x1;
cnt_alloc_container ++;
if (! freelist_container)
{while (! (x1 = (Container)ALLOCMEM_vdmlib(sizeof(struct Handle_container)))) heap_oflw_vdmlib("Heap_container");
cnt_mallc_container ++;
return x1;
}
freelist_container = *((VOIDptr *)(x1 = (Container) freelist_container));
len_mfree_container --;
return x1;
}

void free_container (Container x1)
{len_mfree_container ++;
cnt_free_container ++;
*((VOIDptr *)x1) = freelist_container;
freelist_container = (VOIDptr)x1;
if (len_mfree_container > 100)
{while (len_mfree_container > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_container);
FREEMEM_vdmlib(freelist_container,sizeof(struct Handle_container));
freelist_container = lx1;
len_mfree_container --;
cnt_mfree_container ++;
}
}
}

static Nat0 len_mfree_block = 0;

static Nat0 cnt_alloc_block = 0;
static Nat0 cnt_free_block = 0;
static Nat0 cnt_mallc_block = 0;
static Nat0 cnt_mfree_block = 0;

void profile_block (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Block");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_block);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_block);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_block);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_block);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_block);
fprintf(stderr,"\n");
}

static VOIDptr freelist_block = (VOIDptr)0;

Block alloc_block (void)
{Block x1;
cnt_alloc_block ++;
if (! freelist_block)
{while (! (x1 = (Block)ALLOCMEM_vdmlib(sizeof(struct Handle_block)))) heap_oflw_vdmlib("Heap_block");
cnt_mallc_block ++;
return x1;
}
freelist_block = *((VOIDptr *)(x1 = (Block) freelist_block));
len_mfree_block --;
return x1;
}

void free_block (Block x1)
{len_mfree_block ++;
cnt_free_block ++;
*((VOIDptr *)x1) = freelist_block;
freelist_block = (VOIDptr)x1;
if (len_mfree_block > 100)
{while (len_mfree_block > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_block);
FREEMEM_vdmlib(freelist_block,sizeof(struct Handle_block));
freelist_block = lx1;
len_mfree_block --;
cnt_mfree_block ++;
}
}
}

void forall_rep_blocks (Rep_blocks x1,T2_forall_rep_blocks x2)
{Nat0 lx1 = ref_rep_blocks(x1)->f_len;
Block * px1 = (Block * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Rep_blocks sub_tupd_rep_blocks (Rep_blocks x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_blocks(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_block( ((Block *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_block( ((Block *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Block * px1 = (Block *)(x1+1);
/* start of array */
register Block * px2 = px1 + (x2 - 1);
/* start of substring */
register Block * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_block
extern Cvtext_vdmlib cvlines_block ( Block y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_blocks;
static void _rf1_cvlines1_rep_blocks(Block y1 )

{_rr1_cvlines1_rep_blocks = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_blocks,cvlines_block(y1 )  );}

Cvtext_vdmlib cvlines1_rep_blocks(Rep_blocks x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_blocks;
_rr1_cvlines1_rep_blocks = mk_empty_cvtext_vdmlib();
forall_rep_blocks(x1,_rf1_cvlines1_rep_blocks);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_blocks; _rr1_cvlines1_rep_blocks = lr1; return lr2;}
}

static Rep_blocks _tt1_del_rep_blocks;

static void _ff1_del_rep_blocks(Block y1)

{del_block(y1);}

void del_rep_blocks(Rep_blocks x1)

{
{Rep_blocks lt1; lt1 = _tt1_del_rep_blocks;
{
{_tt1_del_rep_blocks = x1;

{
forall_rep_blocks(x1,_ff1_del_rep_blocks);
del1_rep_blocks(x1);
_tt1_del_rep_blocks = lt1;

}}}}}

Rep_blocks appr_rep_blocks (Rep_blocks x1,Block x2)
{ Nat0 lx1 = ref_rep_blocks(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Block *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_blocks(x1,mk1_rep_blocks(x2)); }
}

Cvtext_vdmlib cvlines_rep_blocks (Rep_blocks x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_blocks(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_blocks(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_blocks ovwrt1d_rep_blocks (Rep_blocks x1,Nat1 x2,Block x3)
{
if (x2 > ref_rep_blocks(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_blocks");
del_block(*( ((Block *)(x1 + 1)) + x2 -1));
*( ((Block *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Rep_blocks copy_rep_blocks (Rep_blocks x1)
{Nat0 l1 = ref_rep_blocks(x1)->f_len;
Rep_blocks x2 = alloc_rep_blocks(l1);
register Block * px1 = (Block *)(x1+1);
register Block * px2 = (Block *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_block(*(px1++));
return x2;
}

Rep_blocks mknc_rep_blocks (Block x1,Nat0 x2)
{ Rep_blocks y1 = alloc_rep_blocks(x2);
Block* y2 = ((Block *)(y1 + 1));

while(x2--) { *(y2++) = copy_block(x1); }
return y1;
}

Rep_blocks conc_rep_blocks (Rep_blocks x1,Rep_blocks x2)
{Nat0 ll1 = ref_rep_blocks(x1)->f_len;
Nat0 ll = ll1 + ref_rep_blocks(x2)->f_len;
if (ll > x1->f_max)
{Rep_blocks lx3 = alloc_rep_blocks(ll);
register Nat0 i = ll1;
register Block * px3 = (Block *)(lx3 + 1);
register Block * px1 = (Block *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_blocks(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Block * px1 = ((Block *)( x1 + 1)) + ll1;
register Block * px2 = (Block *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_blocks(x2);
}
return x1;
}

Rep_blocks tld_rep_blocks (Rep_blocks x1)
{
if (ref_rep_blocks(x1)->f_len == 0) { err_tl_vdmlib("Rep_blocks"); }
return sub_tupd_rep_blocks(x1,(Nat1)2,x1->f_len);
}

Rep_blocks mk1_rep_blocks(Block x1)
{Rep_blocks lx1 = alloc_rep_blocks((Nat0)1);
*((Block *)(lx1+1)) = x1;
return lx1;
}

Block sel_rep_blocks (Rep_blocks x1,Nat1 x2)
{

if (x2 > ref_rep_blocks(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_blocks");
return *( ((Block *)(x1 + 1)) + x2 -1);
}
void del1_rep_blocks (Rep_blocks x1)  {free_rep_blocks(x1);}
void cond_clone_individual (Individual * x1)
{
if ((*x1)->f_rc > 1)
{
Individual clone = alloc_individual();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_individual((*x1)->f_rep);
*x1 = clone;
}
}

Individual chg_chrom_individual(Individual x1,Chromosome x2) { check_handle_individual(x1); cond_clone_individual(&x1); x2 = copy_chromosome(x2); del_chromosome(s_rep_chrom_individual_rep_individual(x1->f_rep)); x1->f_rep = chg_rep_chrom_individual_rep_individual (x1->f_rep,x2); return x1; }

Individual chg_fitness_individual(Individual x1,Real x2) { check_handle_individual(x1); cond_clone_individual(&x1); x2 = copy_real(x2); del_real(s_rep_fitness_individual_rep_individual(x1->f_rep)); x1->f_rep = chg_rep_fitness_individual_rep_individual (x1->f_rep,x2); return x1; }

Cvtext_vdmlib cvlines_individual (Individual x1)
{
check_handle_individual(x1);
return cvlines_rep_individual (x1->f_rep  ) ;
}

#ifdef __cplusplus
void fpr_individual (ostream & x1,Individual x2)
#else
void fpr_individual (FILE * x1,Individual x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_individual(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}
Individual copy_individual (Individual x1)
{
check_handle_individual(x1);
x1->f_rc++;
return x1;
}

Individual mk_individual(

Chromosome x_chrom_individual
,
Real x_fitness_individual

)
{
Individual l = alloc_individual();
l->f_rc = 1;

x_chrom_individual = copy_chromosome( x_chrom_individual );

x_fitness_individual = copy_real( x_fitness_individual );

l->f_rep = mk_rep_individual(

x_chrom_individual
,
x_fitness_individual

);
return l;
}

Chromosome s_chrom_individual(Individual x1) { check_handle_individual(x1); return copy_chromosome(s_rep_chrom_individual_rep_individual(x1->f_rep)); }

Real s_fitness_individual(Individual x1) { check_handle_individual(x1); return copy_real(s_rep_fitness_individual_rep_individual(x1->f_rep)); }

void del_individual (Individual x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_individual(x1->f_rep);
free_individual(x1);
}
}
void cond_clone_blocks (Blocks * x1)
{
if ((*x1)->f_rc > 1)
{
Blocks clone = alloc_blocks();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_blocks((*x1)->f_rep);
*x1 = clone;
}
}
Blocks copy_blocks (Blocks x1)
{
check_handle_blocks(x1);
x1->f_rc++;
return x1;
}

Nat0 len_blocks (Blocks x1)
{
check_handle_blocks(x1);
return len_rep_blocks (x1->f_rep  ) ;
}

Blocks appr_blocks (Blocks x1,Block x2)
{
check_handle_blocks(x1);
cond_clone_blocks(&x1);
x2 = copy_block(x2);
x1->f_rep = appr_rep_blocks (x1->f_rep,x2) ;
return x1;
}
Blocks appl_blocks (Block x1,Blocks x2)
{
check_handle_blocks(x2);
cond_clone_blocks(&x2);
x1 = copy_block(x1);
x2->f_rep = appl_rep_blocks(x1,x2->f_rep);
return x2;
}

Bool is_empty_blocks (Blocks x1)
{
check_handle_blocks(x1);
return is_empty_rep_blocks (x1->f_rep  ) ;
}

Cvtext_vdmlib cvlines_blocks (Blocks x1)
{
check_handle_blocks(x1);
return cvlines_rep_blocks (x1->f_rep  ) ;
}

Blocks ovwrt1_blocks (Blocks x1,Nat1 x2,Block x3)
{
check_handle_blocks(x1);
cond_clone_blocks(&x1);
x3 = copy_block(x3);
x1->f_rep = ovwrt1d_rep_blocks (x1->f_rep,x2,x3) ;
return x1;
}
Blocks mkn_blocks (Block x1,Nat0 x2)
{
Blocks l = alloc_blocks();
l->f_rc = 1;
l->f_rep = mknc_rep_blocks(x1,x2);
return l;
}

#ifdef __cplusplus
void fpr_blocks (ostream & x1,Blocks x2)
#else
void fpr_blocks (FILE * x1,Blocks x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_blocks(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Blocks mk_empty_blocks (void)
{
Blocks l = alloc_blocks();
l->f_rc = 1;
l->f_rep = mk_empty_rep_blocks ();
return l;
}

Block hd_blocks (Blocks x1)
{
check_handle_blocks(x1);
return copy_block(hd_rep_blocks (x1->f_rep));
}

Blocks conc_blocks (Blocks x1,Blocks x2)
{
check_handle_blocks(x1);
check_handle_blocks(x2);
{
Rep_blocks lrep2 = copy_rep_blocks(x2->f_rep);
cond_clone_blocks(&x1);
x1->f_rep = conc_rep_blocks(x1->f_rep,lrep2);
}
return x1;
}

Blocks tl_blocks (Blocks x1)
{
check_handle_blocks(x1);
cond_clone_blocks(&x1);
x1->f_rep = tld_rep_blocks(x1->f_rep);
return x1;
}

Block sel_blocks (Blocks x1,Nat0 x2)
{
check_handle_blocks(x1);
return copy_block(sel_rep_blocks (x1->f_rep,x2));
}

Blocks mk1_blocks (Block x1)
{
Blocks l = alloc_blocks();
l->f_rc = 1;
x1 = copy_block(x1);
l->f_rep = mk1_rep_blocks (x1);
return l;
}
void del_blocks (Blocks x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_blocks(x1->f_rep);
free_blocks(x1);
}
}
Iter_rep_blocks mk_iter_rep_blocks (Rep_blocks x1)  {
Iter_rep_blocks lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_blocks (Iter_rep_blocks * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_blocks");
x1->f_curser++;
}

Block sel_iter_rep_blocks (Iter_rep_blocks * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_blocks");

return
*(((Block *)(x1->f_array +1)) + x1->f_curser);
}

Rep_individuals alloc_rep_individuals (Nat0 x1)
{
Nat0 len = sizeof(struct Struct_rep_individuals) + (x1 + 0) * sizeof(Individual);
Nat0 len2 = 4;
Rep_individuals lx1;
while (len2 < len) len2 += len2;
while (! (lx1 = (Rep_individuals) ALLOCMEM_vdmlib(len2)))
heap_oflw_vdmlib("Rep_individuals");
lx1->f_max = ((len2 - sizeof(struct Struct_rep_individuals))/sizeof(Individual));
lx1->f_len = x1;
;
;
return lx1;
}

void free_rep_individuals (Rep_individuals x1)
{
;

FREEMEM_vdmlib((VOIDptr)x1,sizeof(struct Struct_rep_individuals) + x1->f_max*sizeof(Individual));
}

Iter_blocks mk_iter_blocks (Blocks x1)  {
Iter_blocks lx1;
check_handle_blocks(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_blocks(x1->f_rep);
return lx1;
}

static Nat0 len_mfree_individual = 0;

static Nat0 cnt_alloc_individual = 0;
static Nat0 cnt_free_individual = 0;
static Nat0 cnt_mallc_individual = 0;
static Nat0 cnt_mfree_individual = 0;

void profile_individual (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Individual");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_individual);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_individual);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_individual);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_individual);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_individual);
fprintf(stderr,"\n");
}

static VOIDptr freelist_individual = (VOIDptr)0;

Individual alloc_individual (void)
{Individual x1;
cnt_alloc_individual ++;
if (! freelist_individual)
{while (! (x1 = (Individual)ALLOCMEM_vdmlib(sizeof(struct Handle_individual)))) heap_oflw_vdmlib("Heap_individual");
cnt_mallc_individual ++;
return x1;
}
freelist_individual = *((VOIDptr *)(x1 = (Individual) freelist_individual));
len_mfree_individual --;
return x1;
}

void free_individual (Individual x1)
{len_mfree_individual ++;
cnt_free_individual ++;
*((VOIDptr *)x1) = freelist_individual;
freelist_individual = (VOIDptr)x1;
if (len_mfree_individual > 100)
{while (len_mfree_individual > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_individual);
FREEMEM_vdmlib(freelist_individual,sizeof(struct Handle_individual));
freelist_individual = lx1;
len_mfree_individual --;
cnt_mfree_individual ++;
}
}
}

void forall_rep_individuals (Rep_individuals x1,T2_forall_rep_individuals x2)
{Nat0 lx1 = ref_rep_individuals(x1)->f_len;
Individual * px1 = (Individual * )(x1+1);
while (lx1--) (*x2)(*(px1++));
}

Rep_individuals sub_tupd_rep_individuals (Rep_individuals x1,Nat1 x2,Nat0 x3)
{ if (x3 > ref_rep_individuals(x1)->f_len) { x3 = x1->f_len; }
if (x2 > x3) { x2 = x3 + 1; }
{ register Nat0 i=1; while (i != x2 ) del_individual( ((Individual *)(x1+1))[(i++)-1] ); } { register Nat0 i=x3; while (i != x1->f_len) del_individual( ((Individual *)(x1+1))[(++i)-1] ); }
{ x1->f_len = x3 - x2 + 1;
/* testing and optimizing the case of a truncation */
if (x2 != 1)
{ register Individual * px1 = (Individual *)(x1+1);
/* start of array */
register Individual * px2 = px1 + (x2 - 1);
/* start of substring */
register Individual * pend = px1 + x1->f_len;
/* points behind the end of the new string */
while (px1 != pend) { *(px1++) = *(px2++); }
/* move all elements to the front of the array */
}
}
return x1;
}

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

#ifndef cvlines_individual
extern Cvtext_vdmlib cvlines_individual ( Individual y1    ) ;
#endif

static Cvtext_vdmlib _rr1_cvlines1_rep_individuals;
static void _rf1_cvlines1_rep_individuals(Individual y1 )

{_rr1_cvlines1_rep_individuals = cvlines2_cvtext_vdmlib(_rr1_cvlines1_rep_individuals,cvlines_individual(y1 )  );}

Cvtext_vdmlib cvlines1_rep_individuals(Rep_individuals x1     )

{Cvtext_vdmlib lr1;
lr1 = _rr1_cvlines1_rep_individuals;
_rr1_cvlines1_rep_individuals = mk_empty_cvtext_vdmlib();
forall_rep_individuals(x1,_rf1_cvlines1_rep_individuals);
{Cvtext_vdmlib lr2 = _rr1_cvlines1_rep_individuals; _rr1_cvlines1_rep_individuals = lr1; return lr2;}
}

static Rep_individuals _tt1_del_rep_individuals;

static void _ff1_del_rep_individuals(Individual y1)

{del_individual(y1);}

void del_rep_individuals(Rep_individuals x1)

{
{Rep_individuals lt1; lt1 = _tt1_del_rep_individuals;
{
{_tt1_del_rep_individuals = x1;

{
forall_rep_individuals(x1,_ff1_del_rep_individuals);
del1_rep_individuals(x1);
_tt1_del_rep_individuals = lt1;

}}}}}

Rep_individuals appr_rep_individuals (Rep_individuals x1,Individual x2)
{ Nat0 lx1 = ref_rep_individuals(x1)->f_len;

if (lx1 < x1->f_max)
{ *( ((Individual *)(x1 + 1)) + lx1) = x2;
x1->f_len++;
return x1;
}
else
{ return conc_rep_individuals(x1,mk1_rep_individuals(x2)); }
}

Cvtext_vdmlib cvlines_rep_individuals (Rep_individuals x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "<";
end_structure_vdmlib = ">";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (is_empty_rep_individuals(x1))
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_individuals(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_individuals ovwrt1d_rep_individuals (Rep_individuals x1,Nat1 x2,Individual x3)
{
if (x2 > ref_rep_individuals(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_individuals");
del_individual(*( ((Individual *)(x1 + 1)) + x2 -1));
*( ((Individual *)(x1 + 1)) + x2 -1) = x3;
return x1;
}

Rep_individuals copy_rep_individuals (Rep_individuals x1)
{Nat0 l1 = ref_rep_individuals(x1)->f_len;
Rep_individuals x2 = alloc_rep_individuals(l1);
register Individual * px1 = (Individual *)(x1+1);
register Individual * px2 = (Individual *)(x2+1);
register Nat0 i = 0;
while (i++ != l1) *(px2++) = copy_individual(*(px1++));
return x2;
}

Rep_individuals mknc_rep_individuals (Individual x1,Nat0 x2)
{ Rep_individuals y1 = alloc_rep_individuals(x2);
Individual* y2 = ((Individual *)(y1 + 1));

while(x2--) { *(y2++) = copy_individual(x1); }
return y1;
}

Rep_individuals conc_rep_individuals (Rep_individuals x1,Rep_individuals x2)
{Nat0 ll1 = ref_rep_individuals(x1)->f_len;
Nat0 ll = ll1 + ref_rep_individuals(x2)->f_len;
if (ll > x1->f_max)
{Rep_individuals lx3 = alloc_rep_individuals(ll);
register Nat0 i = ll1;
register Individual * px3 = (Individual *)(lx3 + 1);
register Individual * px1 = (Individual *)( x1 + 1);
while (i--) *(px3++) = *(px1++);
del1_rep_individuals(x1);
x1 = lx3;
}
else x1->f_len = ll;
{register Nat0 i = x2->f_len;
register Individual * px1 = ((Individual *)( x1 + 1)) + ll1;
register Individual * px2 = (Individual *)( x2 + 1);
while (i--) *(px1++) = *(px2++);
del1_rep_individuals(x2);
}
return x1;
}

Rep_individuals tld_rep_individuals (Rep_individuals x1)
{
if (ref_rep_individuals(x1)->f_len == 0) { err_tl_vdmlib("Rep_individuals"); }
return sub_tupd_rep_individuals(x1,(Nat1)2,x1->f_len);
}

Rep_individuals mk1_rep_individuals(Individual x1)
{Rep_individuals lx1 = alloc_rep_individuals((Nat0)1);
*((Individual *)(lx1+1)) = x1;
return lx1;
}

Individual sel_rep_individuals (Rep_individuals x1,Nat1 x2)
{

if (x2 > ref_rep_individuals(x1)->f_len)
err_sel_vdmlib(x2,(Nat0)(x1->f_len),"Rep_individuals");
return *( ((Individual *)(x1 + 1)) + x2 -1);
}
void del1_rep_individuals (Rep_individuals x1)  {free_rep_individuals(x1);}
void cond_clone_individuals (Individuals * x1)
{
if ((*x1)->f_rc > 1)
{
Individuals clone = alloc_individuals();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_individuals((*x1)->f_rep);
*x1 = clone;
}
}
Individuals copy_individuals (Individuals x1)
{
check_handle_individuals(x1);
x1->f_rc++;
return x1;
}

Nat0 len_individuals (Individuals x1)
{
check_handle_individuals(x1);
return len_rep_individuals (x1->f_rep  ) ;
}

Individuals appr_individuals (Individuals x1,Individual x2)
{
check_handle_individuals(x1);
cond_clone_individuals(&x1);
x2 = copy_individual(x2);
x1->f_rep = appr_rep_individuals (x1->f_rep,x2) ;
return x1;
}
Individuals appl_individuals (Individual x1,Individuals x2)
{
check_handle_individuals(x2);
cond_clone_individuals(&x2);
x1 = copy_individual(x1);
x2->f_rep = appl_rep_individuals(x1,x2->f_rep);
return x2;
}

Bool is_empty_individuals (Individuals x1)
{
check_handle_individuals(x1);
return is_empty_rep_individuals (x1->f_rep  ) ;
}

Cvtext_vdmlib cvlines_individuals (Individuals x1)
{
check_handle_individuals(x1);
return cvlines_rep_individuals (x1->f_rep  ) ;
}

Individuals ovwrt1_individuals (Individuals x1,Nat1 x2,Individual x3)
{
check_handle_individuals(x1);
cond_clone_individuals(&x1);
x3 = copy_individual(x3);
x1->f_rep = ovwrt1d_rep_individuals (x1->f_rep,x2,x3) ;
return x1;
}
Individuals mkn_individuals (Individual x1,Nat0 x2)
{
Individuals l = alloc_individuals();
l->f_rc = 1;
l->f_rep = mknc_rep_individuals(x1,x2);
return l;
}

#ifdef __cplusplus
void fpr_individuals (ostream & x1,Individuals x2)
#else
void fpr_individuals (FILE * x1,Individuals x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_individuals(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Individuals mk_empty_individuals (void)
{
Individuals l = alloc_individuals();
l->f_rc = 1;
l->f_rep = mk_empty_rep_individuals ();
return l;
}

Individual hd_individuals (Individuals x1)
{
check_handle_individuals(x1);
return copy_individual(hd_rep_individuals (x1->f_rep));
}

Individuals conc_individuals (Individuals x1,Individuals x2)
{
check_handle_individuals(x1);
check_handle_individuals(x2);
{
Rep_individuals lrep2 = copy_rep_individuals(x2->f_rep);
cond_clone_individuals(&x1);
x1->f_rep = conc_rep_individuals(x1->f_rep,lrep2);
}
return x1;
}

Individuals tl_individuals (Individuals x1)
{
check_handle_individuals(x1);
cond_clone_individuals(&x1);
x1->f_rep = tld_rep_individuals(x1->f_rep);
return x1;
}

Individual sel_individuals (Individuals x1,Nat0 x2)
{
check_handle_individuals(x1);
return copy_individual(sel_rep_individuals (x1->f_rep,x2));
}

Individuals mk1_individuals (Individual x1)
{
Individuals l = alloc_individuals();
l->f_rc = 1;
x1 = copy_individual(x1);
l->f_rep = mk1_rep_individuals (x1);
return l;
}
void del_individuals (Individuals x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_individuals(x1->f_rep);
free_individuals(x1);
}
}
Iter_rep_individuals mk_iter_rep_individuals (Rep_individuals x1)  {
Iter_rep_individuals lx;
lx.f_array = x1;
lx.f_curser = 0;
return lx;
}
void next_iter_rep_individuals (Iter_rep_individuals * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_individuals");
x1->f_curser++;
}

Individual sel_iter_rep_individuals (Iter_rep_individuals * x1)  {
if (x1->f_curser == x1->f_array->f_len)
err_empty_iterator_vdmlib("Iter_rep_individuals");

return
*(((Individual *)(x1->f_array +1)) + x1->f_curser);
}

Iter_individuals mk_iter_individuals (Individuals x1)  {
Iter_individuals lx1;
check_handle_individuals(x1);
x1->f_rc++;
lx1.f_vl = x1;
lx1.f_ir = mk_iter_rep_individuals(x1->f_rep);
return lx1;
}

#ifndef cvlines_individuals
extern Cvtext_vdmlib cvlines_individuals ( Individuals x1   );
#endif
#ifndef cvlines_nat1
extern Cvtext_vdmlib cvlines_nat1 ( Nat1 x1   );
#endif
#ifndef cvlines_nat1
extern Cvtext_vdmlib cvlines_nat1 ( Nat1 x1   );
#endif
#ifndef cvlines_nat1
extern Cvtext_vdmlib cvlines_nat1 ( Nat1 x1   );
#endif
#ifndef cvlines_nat1
extern Cvtext_vdmlib cvlines_nat1 ( Nat1 x1   );
#endif
#ifndef cvlines_nat1
extern Cvtext_vdmlib cvlines_nat1 ( Nat1 x1   );
#endif
#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real x1   );
#endif
#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real x1   );
#endif
#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real x1   );
#endif

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

Cvtext_vdmlib cvlines1_rep_population(Rep_population x1   )

{Cvtext_vdmlib lr1 = mk_empty_cvtext_vdmlib();

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_individuals(s_rep_ind_population_rep_population(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat1(s_rep_popsize_population_rep_population(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat1(s_rep_stringlen_population_rep_population(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat1(s_rep_step_population_rep_population(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat1(s_rep_best_population_rep_population(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat1(s_rep_worst_population_rep_population(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_real(s_rep_bestf_population_rep_population(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_real(s_rep_worstf_population_rep_population(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_real(s_rep_sumfitness_population_rep_population(x1)  )  );

return lr1;
}

void del_rep_population (Rep_population x1)
{

del_individuals(s_rep_ind_population_rep_population(x1));

del_nat1(s_rep_popsize_population_rep_population(x1));

del_nat1(s_rep_stringlen_population_rep_population(x1));

del_nat1(s_rep_step_population_rep_population(x1));

del_nat1(s_rep_best_population_rep_population(x1));

del_nat1(s_rep_worst_population_rep_population(x1));

del_real(s_rep_bestf_population_rep_population(x1));

del_real(s_rep_worstf_population_rep_population(x1));

del_real(s_rep_sumfitness_population_rep_population(x1));

del1_rep_population(x1);
}

Rep_population chg_rep_ind_population_rep_population(Rep_population x1,Individuals x2_rep_ind_population_rep_population)   {x1.f_rep_ind_population_rep_population = x2_rep_ind_population_rep_population;return x1;}

Rep_population chg_rep_popsize_population_rep_population(Rep_population x1,Nat1 x2_rep_popsize_population_rep_population)   {x1.f_rep_popsize_population_rep_population = x2_rep_popsize_population_rep_population;return x1;}

Rep_population chg_rep_stringlen_population_rep_population(Rep_population x1,Nat1 x2_rep_stringlen_population_rep_population)   {x1.f_rep_stringlen_population_rep_population = x2_rep_stringlen_population_rep_population;return x1;}

Rep_population chg_rep_step_population_rep_population(Rep_population x1,Nat1 x2_rep_step_population_rep_population)   {x1.f_rep_step_population_rep_population = x2_rep_step_population_rep_population;return x1;}

Rep_population chg_rep_best_population_rep_population(Rep_population x1,Nat1 x2_rep_best_population_rep_population)   {x1.f_rep_best_population_rep_population = x2_rep_best_population_rep_population;return x1;}

Rep_population chg_rep_worst_population_rep_population(Rep_population x1,Nat1 x2_rep_worst_population_rep_population)   {x1.f_rep_worst_population_rep_population = x2_rep_worst_population_rep_population;return x1;}

Rep_population chg_rep_bestf_population_rep_population(Rep_population x1,Real x2_rep_bestf_population_rep_population)   {x1.f_rep_bestf_population_rep_population = x2_rep_bestf_population_rep_population;return x1;}

Rep_population chg_rep_worstf_population_rep_population(Rep_population x1,Real x2_rep_worstf_population_rep_population)   {x1.f_rep_worstf_population_rep_population = x2_rep_worstf_population_rep_population;return x1;}

Rep_population chg_rep_sumfitness_population_rep_population(Rep_population x1,Real x2_rep_sumfitness_population_rep_population)   {x1.f_rep_sumfitness_population_rep_population = x2_rep_sumfitness_population_rep_population;return x1;}

Cvtext_vdmlib cvlines_rep_population (Rep_population x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "mk_population(";
end_structure_vdmlib = ")";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (0)
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_population(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_population copy_rep_population (Rep_population x1)
{

x1.f_rep_ind_population_rep_population = copy_individuals(x1.f_rep_ind_population_rep_population);

x1.f_rep_popsize_population_rep_population = copy_nat1(x1.f_rep_popsize_population_rep_population);

x1.f_rep_stringlen_population_rep_population = copy_nat1(x1.f_rep_stringlen_population_rep_population);

x1.f_rep_step_population_rep_population = copy_nat1(x1.f_rep_step_population_rep_population);

x1.f_rep_best_population_rep_population = copy_nat1(x1.f_rep_best_population_rep_population);

x1.f_rep_worst_population_rep_population = copy_nat1(x1.f_rep_worst_population_rep_population);

x1.f_rep_bestf_population_rep_population = copy_real(x1.f_rep_bestf_population_rep_population);

x1.f_rep_worstf_population_rep_population = copy_real(x1.f_rep_worstf_population_rep_population);

x1.f_rep_sumfitness_population_rep_population = copy_real(x1.f_rep_sumfitness_population_rep_population);

return x1;
}
Rep_population mk_rep_population(

Individuals x1_rep_ind_population_rep_population
,
Nat1 x1_rep_popsize_population_rep_population
,
Nat1 x1_rep_stringlen_population_rep_population
,
Nat1 x1_rep_step_population_rep_population
,
Nat1 x1_rep_best_population_rep_population
,
Nat1 x1_rep_worst_population_rep_population
,
Real x1_rep_bestf_population_rep_population
,
Real x1_rep_worstf_population_rep_population
,
Real x1_rep_sumfitness_population_rep_population

)

{Rep_population lx1;

lx1.f_rep_ind_population_rep_population = x1_rep_ind_population_rep_population;

lx1.f_rep_popsize_population_rep_population = x1_rep_popsize_population_rep_population;

lx1.f_rep_stringlen_population_rep_population = x1_rep_stringlen_population_rep_population;

lx1.f_rep_step_population_rep_population = x1_rep_step_population_rep_population;

lx1.f_rep_best_population_rep_population = x1_rep_best_population_rep_population;

lx1.f_rep_worst_population_rep_population = x1_rep_worst_population_rep_population;

lx1.f_rep_bestf_population_rep_population = x1_rep_bestf_population_rep_population;

lx1.f_rep_worstf_population_rep_population = x1_rep_worstf_population_rep_population;

lx1.f_rep_sumfitness_population_rep_population = x1_rep_sumfitness_population_rep_population;

return lx1;
}
void cond_clone_population (Population * x1)
{
if ((*x1)->f_rc > 1)
{
Population clone = alloc_population();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_population((*x1)->f_rep);
*x1 = clone;
}
}
Population copy_population (Population x1)
{
check_handle_population(x1);
x1->f_rc++;
return x1;
}
void del_population (Population x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_population(x1->f_rep);
free_population(x1);
}
}

Individuals s_ind_population(Population x1) { check_handle_population(x1); return copy_individuals(s_rep_ind_population_rep_population(x1->f_rep)); }

Nat1 s_popsize_population(Population x1) { check_handle_population(x1); return copy_nat1(s_rep_popsize_population_rep_population(x1->f_rep)); }

Nat1 s_stringlen_population(Population x1) { check_handle_population(x1); return copy_nat1(s_rep_stringlen_population_rep_population(x1->f_rep)); }

Nat1 s_step_population(Population x1) { check_handle_population(x1); return copy_nat1(s_rep_step_population_rep_population(x1->f_rep)); }

Nat1 s_best_population(Population x1) { check_handle_population(x1); return copy_nat1(s_rep_best_population_rep_population(x1->f_rep)); }

Nat1 s_worst_population(Population x1) { check_handle_population(x1); return copy_nat1(s_rep_worst_population_rep_population(x1->f_rep)); }

Real s_bestf_population(Population x1) { check_handle_population(x1); return copy_real(s_rep_bestf_population_rep_population(x1->f_rep)); }

Real s_worstf_population(Population x1) { check_handle_population(x1); return copy_real(s_rep_worstf_population_rep_population(x1->f_rep)); }

Real s_sumfitness_population(Population x1) { check_handle_population(x1); return copy_real(s_rep_sumfitness_population_rep_population(x1->f_rep)); }

Population mk_population(

Individuals x_ind_population
,
Nat1 x_popsize_population
,
Nat1 x_stringlen_population
,
Nat1 x_step_population
,
Nat1 x_best_population
,
Nat1 x_worst_population
,
Real x_bestf_population
,
Real x_worstf_population
,
Real x_sumfitness_population

)
{
Population l = alloc_population();
l->f_rc = 1;

x_ind_population = copy_individuals( x_ind_population );

x_popsize_population = copy_nat1( x_popsize_population );

x_stringlen_population = copy_nat1( x_stringlen_population );

x_step_population = copy_nat1( x_step_population );

x_best_population = copy_nat1( x_best_population );

x_worst_population = copy_nat1( x_worst_population );

x_bestf_population = copy_real( x_bestf_population );

x_worstf_population = copy_real( x_worstf_population );

x_sumfitness_population = copy_real( x_sumfitness_population );

l->f_rep = mk_rep_population(

x_ind_population
,
x_popsize_population
,
x_stringlen_population
,
x_step_population
,
x_best_population
,
x_worst_population
,
x_bestf_population
,
x_worstf_population
,
x_sumfitness_population

);
return l;
}

#ifdef __cplusplus
void fpr_population (ostream & x1,Population x2)
#else
void fpr_population (FILE * x1,Population x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_population(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Cvtext_vdmlib cvlines_population (Population x1)
{
check_handle_population(x1);
return cvlines_rep_population (x1->f_rep  ) ;
}

Population chg_ind_population(Population x1,Individuals x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_individuals(x2); del_individuals(s_rep_ind_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_ind_population_rep_population (x1->f_rep,x2); return x1; }

Population chg_popsize_population(Population x1,Nat1 x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_nat1(x2); del_nat1(s_rep_popsize_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_popsize_population_rep_population (x1->f_rep,x2); return x1; }

Population chg_stringlen_population(Population x1,Nat1 x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_nat1(x2); del_nat1(s_rep_stringlen_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_stringlen_population_rep_population (x1->f_rep,x2); return x1; }

Population chg_step_population(Population x1,Nat1 x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_nat1(x2); del_nat1(s_rep_step_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_step_population_rep_population (x1->f_rep,x2); return x1; }

Population chg_best_population(Population x1,Nat1 x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_nat1(x2); del_nat1(s_rep_best_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_best_population_rep_population (x1->f_rep,x2); return x1; }

Population chg_worst_population(Population x1,Nat1 x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_nat1(x2); del_nat1(s_rep_worst_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_worst_population_rep_population (x1->f_rep,x2); return x1; }

Population chg_bestf_population(Population x1,Real x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_real(x2); del_real(s_rep_bestf_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_bestf_population_rep_population (x1->f_rep,x2); return x1; }

Population chg_worstf_population(Population x1,Real x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_real(x2); del_real(s_rep_worstf_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_worstf_population_rep_population (x1->f_rep,x2); return x1; }

Population chg_sumfitness_population(Population x1,Real x2) { check_handle_population(x1); cond_clone_population(&x1); x2 = copy_real(x2); del_real(s_rep_sumfitness_population_rep_population(x1->f_rep)); x1->f_rep = chg_rep_sumfitness_population_rep_population (x1->f_rep,x2); return x1; }

static Nat0 len_mfree_population = 0;

static Nat0 cnt_alloc_population = 0;
static Nat0 cnt_free_population = 0;
static Nat0 cnt_mallc_population = 0;
static Nat0 cnt_mfree_population = 0;

void profile_population (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Population");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_population);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_population);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_population);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_population);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_population);
fprintf(stderr,"\n");
}

static VOIDptr freelist_population = (VOIDptr)0;

Population alloc_population (void)
{Population x1;
cnt_alloc_population ++;
if (! freelist_population)
{while (! (x1 = (Population)ALLOCMEM_vdmlib(sizeof(struct Handle_population)))) heap_oflw_vdmlib("Heap_population");
cnt_mallc_population ++;
return x1;
}
freelist_population = *((VOIDptr *)(x1 = (Population) freelist_population));
len_mfree_population --;
return x1;
}

void free_population (Population x1)
{len_mfree_population ++;
cnt_free_population ++;
*((VOIDptr *)x1) = freelist_population;
freelist_population = (VOIDptr)x1;
if (len_mfree_population > 100)
{while (len_mfree_population > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_population);
FREEMEM_vdmlib(freelist_population,sizeof(struct Handle_population));
freelist_population = lx1;
len_mfree_population --;
cnt_mfree_population ++;
}
}
}

#ifndef cvlines_nat1
extern Cvtext_vdmlib cvlines_nat1 ( Nat1 x1   );
#endif
#ifndef cvlines_nat1
extern Cvtext_vdmlib cvlines_nat1 ( Nat1 x1   );
#endif
#ifndef cvlines_population
extern Cvtext_vdmlib cvlines_population ( Population x1   );
#endif
#ifndef cvlines_population
extern Cvtext_vdmlib cvlines_population ( Population x1   );
#endif
#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real x1   );
#endif
#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real x1   );
#endif
#ifndef cvlines_real
extern Cvtext_vdmlib cvlines_real ( Real x1   );
#endif
#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1   );
#endif
#ifndef cvlines_container
extern Cvtext_vdmlib cvlines_container ( Container x1   );
#endif

#ifndef cvlines_blocks
extern Cvtext_vdmlib cvlines_blocks ( Blocks x1   );
#endif
#ifndef cvlines_nat0
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1   );
#endif

#ifndef mk_empty_cvtext_vdmlib
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void ) ;
#endif

#ifndef cvlines2_cvtext_vdmlib
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1, Cvtext_vdmlib x2   ) ;
#endif

Cvtext_vdmlib cvlines1_rep_ga(Rep_ga x1   )

{Cvtext_vdmlib lr1 = mk_empty_cvtext_vdmlib();

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat1(s_rep_popsize_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat1(s_rep_stringlen_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_population(s_rep_oldpop_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_population(s_rep_newpop_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_real(s_rep_pcross_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_real(s_rep_pmutation_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_real(s_rep_maxchange_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat0(s_rep_generation_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_container(s_rep_con_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_blocks(s_rep_bl_ga_rep_ga(x1)  )  );

lr1 = cvlines2_cvtext_vdmlib(lr1,cvlines_nat0(s_rep_containers_ga_rep_ga(x1)  )  );

return lr1;
}

void del_rep_ga (Rep_ga x1)
{

del_nat1(s_rep_popsize_ga_rep_ga(x1));

del_nat1(s_rep_stringlen_ga_rep_ga(x1));

del_population(s_rep_oldpop_ga_rep_ga(x1));

del_population(s_rep_newpop_ga_rep_ga(x1));

del_real(s_rep_pcross_ga_rep_ga(x1));

del_real(s_rep_pmutation_ga_rep_ga(x1));

del_real(s_rep_maxchange_ga_rep_ga(x1));

del_nat0(s_rep_generation_ga_rep_ga(x1));

del_container(s_rep_con_ga_rep_ga(x1));

del_blocks(s_rep_bl_ga_rep_ga(x1));

del_nat0(s_rep_containers_ga_rep_ga(x1));

del1_rep_ga(x1);
}

Rep_ga chg_rep_popsize_ga_rep_ga(Rep_ga x1,Nat1 x2_rep_popsize_ga_rep_ga)   {x1.f_rep_popsize_ga_rep_ga = x2_rep_popsize_ga_rep_ga;return x1;}

Rep_ga chg_rep_stringlen_ga_rep_ga(Rep_ga x1,Nat1 x2_rep_stringlen_ga_rep_ga)   {x1.f_rep_stringlen_ga_rep_ga = x2_rep_stringlen_ga_rep_ga;return x1;}

Rep_ga chg_rep_oldpop_ga_rep_ga(Rep_ga x1,Population x2_rep_oldpop_ga_rep_ga)   {x1.f_rep_oldpop_ga_rep_ga = x2_rep_oldpop_ga_rep_ga;return x1;}

Rep_ga chg_rep_newpop_ga_rep_ga(Rep_ga x1,Population x2_rep_newpop_ga_rep_ga)   {x1.f_rep_newpop_ga_rep_ga = x2_rep_newpop_ga_rep_ga;return x1;}

Rep_ga chg_rep_pcross_ga_rep_ga(Rep_ga x1,Real x2_rep_pcross_ga_rep_ga)   {x1.f_rep_pcross_ga_rep_ga = x2_rep_pcross_ga_rep_ga;return x1;}

Rep_ga chg_rep_pmutation_ga_rep_ga(Rep_ga x1,Real x2_rep_pmutation_ga_rep_ga)   {x1.f_rep_pmutation_ga_rep_ga = x2_rep_pmutation_ga_rep_ga;return x1;}

Rep_ga chg_rep_maxchange_ga_rep_ga(Rep_ga x1,Real x2_rep_maxchange_ga_rep_ga)   {x1.f_rep_maxchange_ga_rep_ga = x2_rep_maxchange_ga_rep_ga;return x1;}

Rep_ga chg_rep_generation_ga_rep_ga(Rep_ga x1,Nat0 x2_rep_generation_ga_rep_ga)   {x1.f_rep_generation_ga_rep_ga = x2_rep_generation_ga_rep_ga;return x1;}

Rep_ga chg_rep_con_ga_rep_ga(Rep_ga x1,Container x2_rep_con_ga_rep_ga)   {x1.f_rep_con_ga_rep_ga = x2_rep_con_ga_rep_ga;return x1;}

Rep_ga chg_rep_bl_ga_rep_ga(Rep_ga x1,Blocks x2_rep_bl_ga_rep_ga)   {x1.f_rep_bl_ga_rep_ga = x2_rep_bl_ga_rep_ga;return x1;}

Rep_ga chg_rep_containers_ga_rep_ga(Rep_ga x1,Nat0 x2_rep_containers_ga_rep_ga)   {x1.f_rep_containers_ga_rep_ga = x2_rep_containers_ga_rep_ga;return x1;}

Cvtext_vdmlib cvlines_rep_ga (Rep_ga x1)
{
{ Nat0 lx1 = curr_linelen_vdmlib;
char *lx2 = start_structure_vdmlib;
char *lx3 = end_structure_vdmlib;
Cvtext_vdmlib lx4;
Nat0 lx5;

start_structure_vdmlib = "mk_ga(";
end_structure_vdmlib = ")";
lx5 = (Nat0)strlen(start_structure_vdmlib);
adj_linelen_vdmlib(lx5);

if (0)
lx4 = mk1_cvtext_vdmlib(conc_str( mkc_str(start_structure_vdmlib)
, mkc_str(end_structure_vdmlib)));
else
lx4 = close_struct_vdmlib( cvlines1_rep_ga(x1)
, mkc_str(end_structure_vdmlib)
, lx5
);

curr_linelen_vdmlib = lx1;
start_structure_vdmlib = lx2;
end_structure_vdmlib = lx3;
return lx4;
}
}

Rep_ga copy_rep_ga (Rep_ga x1)
{

x1.f_rep_popsize_ga_rep_ga = copy_nat1(x1.f_rep_popsize_ga_rep_ga);

x1.f_rep_stringlen_ga_rep_ga = copy_nat1(x1.f_rep_stringlen_ga_rep_ga);

x1.f_rep_oldpop_ga_rep_ga = copy_population(x1.f_rep_oldpop_ga_rep_ga);

x1.f_rep_newpop_ga_rep_ga = copy_population(x1.f_rep_newpop_ga_rep_ga);

x1.f_rep_pcross_ga_rep_ga = copy_real(x1.f_rep_pcross_ga_rep_ga);

x1.f_rep_pmutation_ga_rep_ga = copy_real(x1.f_rep_pmutation_ga_rep_ga);

x1.f_rep_maxchange_ga_rep_ga = copy_real(x1.f_rep_maxchange_ga_rep_ga);

x1.f_rep_generation_ga_rep_ga = copy_nat0(x1.f_rep_generation_ga_rep_ga);

x1.f_rep_con_ga_rep_ga = copy_container(x1.f_rep_con_ga_rep_ga);

x1.f_rep_bl_ga_rep_ga = copy_blocks(x1.f_rep_bl_ga_rep_ga);

x1.f_rep_containers_ga_rep_ga = copy_nat0(x1.f_rep_containers_ga_rep_ga);

return x1;
}
Rep_ga mk_rep_ga(

Nat1 x1_rep_popsize_ga_rep_ga
,
Nat1 x1_rep_stringlen_ga_rep_ga
,
Population x1_rep_oldpop_ga_rep_ga
,
Population x1_rep_newpop_ga_rep_ga
,
Real x1_rep_pcross_ga_rep_ga
,
Real x1_rep_pmutation_ga_rep_ga
,
Real x1_rep_maxchange_ga_rep_ga
,
Nat0 x1_rep_generation_ga_rep_ga
,
Container x1_rep_con_ga_rep_ga

,
Blocks x1_rep_bl_ga_rep_ga
,
Nat0 x1_rep_containers_ga_rep_ga

)

{Rep_ga lx1;

lx1.f_rep_popsize_ga_rep_ga = x1_rep_popsize_ga_rep_ga;

lx1.f_rep_stringlen_ga_rep_ga = x1_rep_stringlen_ga_rep_ga;

lx1.f_rep_oldpop_ga_rep_ga = x1_rep_oldpop_ga_rep_ga;

lx1.f_rep_newpop_ga_rep_ga = x1_rep_newpop_ga_rep_ga;

lx1.f_rep_pcross_ga_rep_ga = x1_rep_pcross_ga_rep_ga;

lx1.f_rep_pmutation_ga_rep_ga = x1_rep_pmutation_ga_rep_ga;

lx1.f_rep_maxchange_ga_rep_ga = x1_rep_maxchange_ga_rep_ga;

lx1.f_rep_generation_ga_rep_ga = x1_rep_generation_ga_rep_ga;

lx1.f_rep_con_ga_rep_ga = x1_rep_con_ga_rep_ga;

lx1.f_rep_bl_ga_rep_ga = x1_rep_bl_ga_rep_ga;

lx1.f_rep_containers_ga_rep_ga = x1_rep_containers_ga_rep_ga;

return lx1;
}
void cond_clone_ga (Ga * x1)
{
if ((*x1)->f_rc > 1)
{
Ga clone = alloc_ga();
clone->f_rc = 1;
(*x1)->f_rc--;
clone->f_rep = copy_rep_ga((*x1)->f_rep);
*x1 = clone;
}
}

Ga chg_popsize_ga(Ga x1,Nat1 x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_nat1(x2); del_nat1(s_rep_popsize_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_popsize_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_stringlen_ga(Ga x1,Nat1 x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_nat1(x2); del_nat1(s_rep_stringlen_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_stringlen_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_oldpop_ga(Ga x1,Population x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_population(x2); del_population(s_rep_oldpop_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_oldpop_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_newpop_ga(Ga x1,Population x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_population(x2); del_population(s_rep_newpop_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_newpop_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_pcross_ga(Ga x1,Real x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_real(x2); del_real(s_rep_pcross_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_pcross_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_pmutation_ga(Ga x1,Real x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_real(x2); del_real(s_rep_pmutation_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_pmutation_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_maxchange_ga(Ga x1,Real x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_real(x2); del_real(s_rep_maxchange_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_maxchange_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_generation_ga(Ga x1,Nat0 x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_nat0(x2); del_nat0(s_rep_generation_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_generation_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_con_ga(Ga x1,Container x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_container(x2); del_container(s_rep_con_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_con_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_bl_ga(Ga x1,Blocks x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_blocks(x2); del_blocks(s_rep_bl_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_bl_ga_rep_ga (x1->f_rep,x2); return x1; }

Ga chg_containers_ga(Ga x1,Nat0 x2) { check_handle_ga(x1); cond_clone_ga(&x1); x2 = copy_nat0(x2); del_nat0(s_rep_containers_ga_rep_ga(x1->f_rep)); x1->f_rep = chg_rep_containers_ga_rep_ga (x1->f_rep,x2); return x1; }

Cvtext_vdmlib cvlines_ga (Ga x1)
{
check_handle_ga(x1);
return cvlines_rep_ga (x1->f_rep  ) ;
}

#ifdef __cplusplus
void fpr_ga (ostream & x1,Ga x2)
#else
void fpr_ga (FILE * x1,Ga x2)
#endif
{ Cvtext_vdmlib lx1;
curr_linelen_vdmlib = 80;
lx1 = cvlines_ga(x2);
fprint_lines_vdmlib(x1,lx1);
del_cvtext_vdmlib(lx1);
}

Ga mk_ga(

Nat1 x_popsize_ga
,
Nat1 x_stringlen_ga
,
Population x_oldpop_ga
,
Population x_newpop_ga
,
Real x_pcross_ga
,
Real x_pmutation_ga
,
Real x_maxchange_ga
,
Nat0 x_generation_ga
,
Container x_con_ga

,
Blocks x_bl_ga
,
Nat0 x_containers_ga

)
{
Ga l = alloc_ga();
l->f_rc = 1;

x_popsize_ga = copy_nat1( x_popsize_ga );

x_stringlen_ga = copy_nat1( x_stringlen_ga );

x_oldpop_ga = copy_population( x_oldpop_ga );

x_newpop_ga = copy_population( x_newpop_ga );

x_pcross_ga = copy_real( x_pcross_ga );

x_pmutation_ga = copy_real( x_pmutation_ga );

x_maxchange_ga = copy_real( x_maxchange_ga );

x_generation_ga = copy_nat0( x_generation_ga );

x_con_ga = copy_container( x_con_ga );

x_bl_ga = copy_blocks( x_bl_ga );

x_containers_ga = copy_nat0( x_containers_ga );

l->f_rep = mk_rep_ga(

x_popsize_ga
,
x_stringlen_ga
,
x_oldpop_ga
,
x_newpop_ga
,
x_pcross_ga
,
x_pmutation_ga
,
x_maxchange_ga
,
x_generation_ga
,
x_con_ga

,
x_bl_ga
,
x_containers_ga

);
return l;
}

Nat1 s_popsize_ga(Ga x1) { check_handle_ga(x1); return copy_nat1(s_rep_popsize_ga_rep_ga(x1->f_rep)); }

Nat1 s_stringlen_ga(Ga x1) { check_handle_ga(x1); return copy_nat1(s_rep_stringlen_ga_rep_ga(x1->f_rep)); }

Population s_oldpop_ga(Ga x1) { check_handle_ga(x1); return copy_population(s_rep_oldpop_ga_rep_ga(x1->f_rep)); }

Population s_newpop_ga(Ga x1) { check_handle_ga(x1); return copy_population(s_rep_newpop_ga_rep_ga(x1->f_rep)); }

Real s_pcross_ga(Ga x1) { check_handle_ga(x1); return copy_real(s_rep_pcross_ga_rep_ga(x1->f_rep)); }

Real s_pmutation_ga(Ga x1) { check_handle_ga(x1); return copy_real(s_rep_pmutation_ga_rep_ga(x1->f_rep)); }

Real s_maxchange_ga(Ga x1) { check_handle_ga(x1); return copy_real(s_rep_maxchange_ga_rep_ga(x1->f_rep)); }

Nat0 s_generation_ga(Ga x1) { check_handle_ga(x1); return copy_nat0(s_rep_generation_ga_rep_ga(x1->f_rep)); }

Container s_con_ga(Ga x1) { check_handle_ga(x1); return copy_container(s_rep_con_ga_rep_ga(x1->f_rep)); }

Blocks s_bl_ga(Ga x1) { check_handle_ga(x1); return copy_blocks(s_rep_bl_ga_rep_ga(x1->f_rep)); }

Nat0 s_containers_ga(Ga x1) { check_handle_ga(x1); return copy_nat0(s_rep_containers_ga_rep_ga(x1->f_rep)); }

void del_ga (Ga x1)
{
if ((x1 != 0) && (--x1->f_rc == 0))
{
del_rep_ga(x1->f_rep);
free_ga(x1);
}
}

static Nat0 len_mfree_ga = 0;

static Nat0 cnt_alloc_ga = 0;
static Nat0 cnt_free_ga = 0;
static Nat0 cnt_mallc_ga = 0;
static Nat0 cnt_mfree_ga = 0;

void profile_ga (void)
{fprintf(stderr,"\n  profiling allocation of domain %s","Ga");
fprintf(stderr,"\n  strategie : bounded freelist with max. length %ld",(long)100);
fprintf(stderr,"\n     calls of alloc     : %10ld",(long)cnt_alloc_ga);
fprintf(stderr,"\n     calls of free      : %10ld",(long)cnt_free_ga);
fprintf(stderr,"\n     calls of C malloc  : %10ld",(long)cnt_mallc_ga);
fprintf(stderr,"\n     calls of C free    : %10ld",(long)cnt_mfree_ga);
fprintf(stderr,"\n     length of freelist : %10ld",(long)len_mfree_ga);
fprintf(stderr,"\n");
}

static VOIDptr freelist_ga = (VOIDptr)0;

Ga alloc_ga (void)
{Ga x1;
cnt_alloc_ga ++;
if (! freelist_ga)
{while (! (x1 = (Ga)ALLOCMEM_vdmlib(sizeof(struct Handle_ga)))) heap_oflw_vdmlib("Heap_ga");
cnt_mallc_ga ++;
return x1;
}
freelist_ga = *((VOIDptr *)(x1 = (Ga) freelist_ga));
len_mfree_ga --;
return x1;
}

void free_ga (Ga x1)
{len_mfree_ga ++;
cnt_free_ga ++;
*((VOIDptr *)x1) = freelist_ga;
freelist_ga = (VOIDptr)x1;
if (len_mfree_ga > 100)
{while (len_mfree_ga > 100 / 2)
{VOIDptr lx1 = *((VOIDptr *) freelist_ga);
FREEMEM_vdmlib(freelist_ga,sizeof(struct Handle_ga));
freelist_ga = lx1;
len_mfree_ga --;
cnt_mfree_ga ++;
}
}
}
